VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DBF"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Type Field_Info
    Name As String
    StringData_Flag As Boolean
    Length As Byte
    PointLen As Byte
End Type
Private Type DBF_Info
    VerData As Byte
    RecordNumber As Long
    FieldNumber As Long
    Year As Byte
    Month As Byte
    Date As Byte
    Header_Byte As Integer
    Record_Byte As Integer
End Type
Dim DataSet As DBF_Info
Dim FieldDT() As Field_Info
Dim DataStr() As String
Public Sub Init(ByVal FieldNum As Long, RecordNum As Long)
    DataSet.FieldNumber = FieldNum
    DataSet.RecordNumber = RecordNum
    
    ReDim FieldDT(FieldNum - 1)
    ReDim DataStr(FieldNum - 1, RecordNum - 1)
End Sub
Public Property Get FieldNumber() As Long
    FieldNumber = DataSet.FieldNumber
End Property
Public Property Get RecordNumber() As Long
    RecordNumber = DataSet.RecordNumber
End Property
Public Property Get FieldName(ByVal Num As Long) As String
    FieldName = FieldDT(Num).Name
End Property
Public Property Let FieldName(ByVal Num As Long, ByRef FieldName As String)
    FieldDT(Num).Name = FieldName
End Property
Public Property Get FieldStringData_Flag(ByVal Num As Long) As Boolean
    FieldStringData_Flag = FieldDT(Num).StringData_Flag
End Property
Public Property Let FieldStringData_Flag(ByVal Num As Long, ByVal FieldStringData_Flag As Boolean)
    FieldDT(Num).StringData_Flag = FieldStringData_Flag
End Property
Public Property Get DataValue(ByVal FieldNum As Long, RecordNum As Long) As String
    DataValue = DataStr(FieldNum, RecordNum)
End Property
Public Property Get DataValue_Allay() As String()
    DataValue_Allay = DataStr
End Property
Public Sub DataValueSet(ByVal FieldNum As Long, RecordNum As Long, ByRef DataV As String)
     DataStr(FieldNum, RecordNum) = DataV
End Sub
Public Sub DataValueSet_Allay(ByRef DataV() As String)
     DataStr = DataV
End Sub


Public Function SaveDBF(ByRef FilePath As String) As Boolean
Dim i As Long, j As Long
Dim BData As Byte, BData0 As Byte, DT As String


    BData0 = 0
    On Error Resume Next
    Open FilePath For Binary As #1
    If Err Then
        MsgBox Err.Description
        Err.Clear
        On Error GoTo 0
        SaveDBF = False
        Exit Function
    End If
    On Error GoTo 0

    Call Check_FieldLength

    BData = 3
    Put #1, , BData
    With DataSet
        .Year = Year(Now) - 1900
        .Month = Month(Now)
        .Date = Day(Now)
        .Header_Byte = .FieldNumber * 32 + 33
        .Record_Byte = 0
        For i = 0 To .FieldNumber - 1
            .Record_Byte = .Record_Byte + FieldDT(i).Length
        Next
        .Record_Byte = .Record_Byte + 1
        Put #1, , .Year
        Put #1, , .Month
        Put #1, , .Date
    
        Put #1, , .RecordNumber
        Put #1, , .Header_Byte
        Put #1, , .Record_Byte
    End With
    For i = 12 To 31
        Put #1, , BData0
    Next
    
    'tB[hLqq

    For i = 0 To DataSet.FieldNumber - 1
        With FieldDT(i)
            j = 0
            Call Put_Strings(1, .Name, 11, Chr(0))
            If .StringData_Flag = True Then
                BData = Asc("C")
            Else
                BData = Asc("N")
            End If
            Put #1, , BData
            Put #1, , BData0
            Put #1, , BData0
            Put #1, , BData0
            Put #1, , BData0
            
            Put #1, , .Length
            Put #1, , .PointLen '_ȉ̌
            
            For j = 18 To 30
                Put #1, , BData0
            Next
            Put #1, , BData0
        End With
    Next
    BData = &HD
    Put #1, , BData  '&HD
    'f[^x[XR[h
    For i = 0 To DataSet.RecordNumber - 1
        BData = &H20
        Put #1, , BData
        For j = 0 To DataSet.FieldNumber - 1
            DT = Conv_ValStr(DataStr(j, i), j)
            Call Put_Strings(1, DT, FieldDT(j).Length, " ")
        Next
    Next
    BData = &H1A
    Put #1, , BData '^[~l[^@&h1A
    Close
    SaveDBF = True

End Function
Private Sub Put_Strings(ByVal Filenumber As Long, ByRef DT As String, ByVal MaxLength As Long, ByRef NullSTR As String)
Dim j As Long, w As Long
Dim DTCode As String
Dim BData As Byte
    j = 0
    w = 1
    Do
        If w <= Len(DT) Then
            DTCode = Hex(Asc(Mid(DT, w, 1)))
            If Len(DTCode) <= 2 Then
                BData = Val("&H" & DTCode)
                Put #1, , BData
                j = j + 1
            Else
                If j = MaxLength - 1 Then
                    BData = Asc(NullSTR)
                    Put #1, , BData
                Else
                    DTCode = right("00" & DTCode, 4)
                    BData = Val("&H" & Mid(DTCode, 1, 2))
                    Put #1, , BData
                    BData = Val("&H" & Mid(DTCode, 3, 2))
                    Put #1, , BData
                End If
                j = j + 2
            End If
        Else
            BData = Asc(NullSTR)
            Put #1, , BData
            j = j + 1
        End If
        w = w + 1
    Loop While j < MaxLength

End Sub

Private Function Conv_ValStr(ByVal DataStr As String, ByVal FieldNum As Long) As String
Dim DV As Double
Dim a As String

    With FieldDT(FieldNum)
    If .StringData_Flag = True Then
        Conv_ValStr = DataStr & String(.Length - Len(DataStr), " ")
    Else
        DV = Val(DataStr)
        a = FormatNumber(DV, .PointLen, vbTrue, vbFalse, vbFalse)
        Conv_ValStr = String(.Length - Len(a), " ") + a
    End If
    End With
End Function
Private Sub Check_FieldLength()
Dim i As Long, j As Long, k As Long
Dim L As Long, r As Long
Dim Shosuten As Long, Hidari As Long
Dim Minv As Double, V As Double
Dim DTCode As String, L2 As Long

    For i = 0 To DataSet.FieldNumber - 1
        If FieldDT(i).StringData_Flag = True Then
            L = -1
            For k = 0 To DataSet.RecordNumber - 1
                L2 = 0
                For j = 1 To Len(DataStr(i, k))
                    DTCode = Hex(Asc(Mid(DataStr(i, k), j, 1)))
                    If Len(DTCode) <= 2 Then
                        L2 = L2 + 1
                    Else
                        L2 = L2 + 2
                    End If
                Next
                L = mx(L, L2)
            Next
            If L = 0 Then
                L = 1
            End If
            FieldDT(i).Length = L
            FieldDT(i).PointLen = 0
        Else
            Minv = Val(DataStr(i, 0))
            Call Figure_Arrange(Minv, Hidari, Shosuten)
            For j = 1 To DataSet.RecordNumber - 1
                V = Val(DataStr(i, j))
                Call Figure_Arrange(V, L, r)
                Hidari = mx(L, Hidari)
                Shosuten = mx(Shosuten, r)
                If Minv > V Then
                    Minv = V
                End If
            Next
            If Hidari = 0 Then
                Hidari = 1
            End If
            If Minv < 0 Then
                Hidari = Hidari + 1
            End If
            If Shosuten > 0 Then
                Hidari = Hidari + 1
            End If
            FieldDT(i).Length = Shosuten + Hidari
            FieldDT(i).PointLen = Shosuten
        End If
    Next
End Sub
Public Function LoadDBF(ByRef FilePath As String) As Boolean
Dim i As Long, j As Long
Dim BData As Byte


    On Error Resume Next
    Open FilePath For Binary As #1
    If Err Then
        MsgBox Err.Description
        Err.Clear
        On Error GoTo 0
        LoadDBF = False
        Exit Function
    End If
    On Error GoTo 0
    Get #1, , DataSet.VerData  'Ver=3  = VerData And 7
    
    'ŏIXV
    Get #1, , DataSet.Year  'Year-1900
    Get #1, , DataSet.Month
    Get #1, , DataSet.Date
    
    Get #1, , DataSet.RecordNumber
    Get #1, , DataSet.Header_Byte '33+FieldNum*32
    DataSet.FieldNumber = (DataSet.Header_Byte - 33) \ 32
    Get #1, , DataSet.Record_Byte 'sum(FieldDT().Length)+1
    Get #1, , BData
    Get #1, , BData
    
    Get #1, , BData
    Get #1, , BData
    
    For i = 16 To 27
        Get #1, , BData
    Next
    Get #1, , BData
    Get #1, , BData 'hCoID
    
    Get #1, , BData
    Get #1, , BData
        
    'tB[hLqqzǂݍ
    ReDim FieldDT(DataSet.FieldNumber - 1)
    
    For i = 0 To DataSet.FieldNumber - 1
        With FieldDT(i)
            .Name = Trim(Get_WCharData(1, 11))
            Get #1, , BData
            Select Case Chr(BData)
                Case "C", "D", "M", "L"
                    .StringData_Flag = True
                Case "F", "N"
                    .StringData_Flag = False
            End Select
            Get #1, , BData
            Get #1, , BData
            Get #1, , BData
            Get #1, , BData
            
            Get #1, , .Length
            Get #1, , .PointLen
            
            Get #1, , BData
            Get #1, , BData
            Get #1, , BData
            For j = 1 To 10
                Get #1, , BData
            Next
            Get #1, , BData
        End With
    Next
    Get #1, , BData  '&HD
    
    'f[^x[XR[hǂݍ
    ReDim DataStr(DataSet.FieldNumber - 1, DataSet.RecordNumber - 1)
    For i = 0 To DataSet.RecordNumber - 1
        Get #1, , BData '폜ĂȂΔp(&h20)A폜Ă΃AX^XN(&h2A)
        For j = 0 To DataSet.FieldNumber - 1
            DataStr(j, i) = Trim(Get_WCharData(1, FieldDT(j).Length))
        Next
    Next
    Get #1, , BData '^[~l[^@&h1A
    Close
    LoadDBF = True
End Function
Private Function Get_WCharData(ByVal FileNum As Long, ByVal GetLen As Long) As String
'e00t@CPATɂQoCg܂܂Ă邱Ƃ̂ŁA
'̂߂̃t@Cǂݍ݃vV[W
Dim a As Byte
Dim a2 As Long
Dim aa As Byte
Dim i As Long
Dim b$, c$

    b$ = ""
    c$ = ""
    For i = 1 To GetLen
        c$ = InputB(FileNum, 1)
        a = AscB(c$)
        If a > 128 Then
            c$ = InputB(FileNum, 1)
            aa = AscB(c$)
            a2 = Val("&h" & Hex$(a) & right$("00" & Hex$(aa), 2))
            i = i + 1
           b$ = b$ & Chr(a2)
        Else
            If a <> 10 And a <> 13 And a <> 0 Then
               b$ = b$ & Chr(a)
            End If
        End If
    Next
    Get_WCharData = b$
End Function

