Attribute VB_Name = "Draw_Mark_Fan"
Option Explicit

Sub Mark_Print(ByVal ax, ByVal ay, ByVal r, Mark As Mark_Property, ByVal O_HDC As Long, ByVal Size_mode As Integer)
Dim i As Long, j As Long, n As Long, mk_fign As Long, Shape As Long
Dim ln As Long, oln As Long, ln2 As Long, poln As Long, ln3 As Long
Dim RR As Single, mkn As Long
Dim en_xy() As POINTAPI
Dim pxy() As POINTAPI, nPolyP() As Long
Dim W_Font As Font_Property, f As Boolean
Dim Circle_Tile As Tile_Property

    With Mark
    Select Case .PrintMark
    Case 0
        Draw_Tile_Box ax - r, ay - r, ax + r, ay + r, .WordFont.Body.Kakudo, Mark.WordFont.FrameLine, Mark.WordFont.Tile, O_HDC, Size_mode
        mkn = 0
        n = Mark_Pointer(.Shape)
        mk_fign = Mark_Stac(n)
        n = n + 1
        Do
            Shape = Mark_Stac(n)
            n = n + 1
            Select Case Shape
                Case 0
                    If Mark_Stac(n + 4) = 1 Then
                        Circle_Tile = .Tile
                    Else
                        Circle_Tile = Base.Tile
                        Circle_Tile.TileCode = 7
                    End If
                    Draw_DAEN ax + Mark_Stac(n) * r / 100, ay + Mark_Stac(n + 1) * r / 100, Mark_Stac(n + 2) * r / 100 _
                        , Mark_Stac(n + 3) * r / 100, .WordFont.Body.Kakudo, .Line, Circle_Tile, True, O_HDC, Size_mode
                    n = n + 5
                Case 1 '|S
                    poln = Mark_Stac(n)
                    n = n + 1
                    ln2 = 0
                    ReDim pxy(100)
                    ReDim nPolyP(poln - 1)
                    For j = 0 To poln - 1
                        ln = Mark_Stac(n)
                        oln = ln2
                        n = n + 1
                        If ln = -1 Then '~̏ꍇ
                            f = Get_DAEN_Peri_XY(ax + r * Mark_Stac(n) / 100, ay + r * Mark_Stac(n + 1) / 100, _
                                r * Mark_Stac(n + 2) / 100, r * Mark_Stac(n + 3) / 100, .WordFont.Body.Kakudo, True, ln3, en_xy(), 0)
                            n = n + 4
                            ln2 = ln2 + ln3
                            If UBound(pxy) < ln2 Then
                                ReDim Preserve pxy(ln2 - 1)
                            End If
                            For i = 0 To ln3 - 1
                                pxy(oln + i) = en_xy(i)
                            Next
                        Else  'ʏ̑p`
                            ln2 = ln2 + ln
                            If UBound(pxy) < ln2 Then
                                ReDim Preserve pxy(ln2 - 1)
                            End If
                            For i = 0 To ln - 1
                                With pxy(oln + i)
                                .X = r * Mark_Stac(n)
                                .Y = r * Mark_Stac(n + 1)
                                Trans2D .X, .Y, -Mark.WordFont.Body.Kakudo
                                .X = .X / 100 + ax
                                .Y = .Y / 100 + ay
                                End With
                                n = n + 2
                            Next
                            ln3 = ln
                        End If
                        nPolyP(j) = ln3
                    Next
                    Draw_Tile_and_Paint_and_Line pxy(), nPolyP(), poln, .Tile, .Line, O_HDC, Size_mode
                Case 2
                    ln = Mark_Stac(n)
                    n = n + 1
                    ReDim pxy(ln - 1)
                    For i = 0 To ln - 1
                        With pxy(i)
                        .X = r * Mark_Stac(n)
                        .Y = r * Mark_Stac(n + 1)
                        Trans2D .X, .Y, -Mark.WordFont.Body.Kakudo
                        .X = .X / 100 + ax
                        .Y = .Y / 100 + ay
                        End With
                        n = n + 2
                    Next
                    Draw_PolyLine pxy(), ln, .Line, O_HDC, Size_mode
            End Select
            mkn = mkn + 1
        Loop While mkn < mk_fign

    Case 1
        W_Font = .WordFont
        If r = 0 Then r = 1
        W_Font.Body.Size = Get_Length_On_BaseMap(r * 2)
        Draw_Print ax, ay, .wordmark, 1, 1, W_Font, O_HDC, Size_mode
    Case 2
        Draw_Tile_Box ax - r, ay - r, ax + r, ay + r, .WordFont.Body.Kakudo, Mark.WordFont.FrameLine, Mark.WordFont.Tile, O_HDC, Size_mode
        Call Gazo_Print(.PictureNumber, ax, ay, r, .WordFont.Body.Kakudo, True, .WordFont.Body.Color, Mark.WordFont.FrameLine, O_HDC, False, Size_mode)
    End Select
    End With
End Sub

Public Function Mark_Set_With_Tile(Mark As Mark_Property) As Boolean

    Push.Mark = Mark
    frmMark_Set.Show 1
    
    If Cancel_Button = False Then
        Mark_Set_With_Tile = True
        Mark = Push.Mark
    Else
        Mark_Set_With_Tile = False
    End If

    Unload frmMark_Set
End Function

Sub Draw_Fan(ByVal cx As Long, ByVal cy As Long, ByVal r As Long, ByVal start_p As Double, ByVal end_p As Double, L As Line_Property, Tile As Tile_Property, ByVal O_HDC As Long, ByVal Size_mode As Integer)
Dim i As Single
Dim cn As Long
Dim pxy() As POINTAPI, nPolyn(0) As Long
Dim ST As Double, dtn As Long

'    If Tile.TileCode <= 6 Then
        ST = 1 / (r * 2 / 5)
        
        dtn = Int((end_p - start_p) / ST + 10)
        ReDim pxy(dtn - 1)
        cn = 0

        If start_p = 0 And end_p = PI * 2 Then
        Else
            pxy(0).X = cx
            pxy(0).Y = cy
            cn = cn + 1
        End If
        
        If end_p - start_p < ST Then
            pxy(cn).X = r * Sin(start_p) + cx
            pxy(cn).Y = -r * Cos(start_p) + cy
            cn = cn + 1
        Else
        For i = start_p To end_p - ST Step ST
            pxy(cn).X = r * Sin(i) + cx
            pxy(cn).Y = -r * Cos(i) + cy
            cn = cn + 1
        Next
        End If
        pxy(cn).X = r * Sin(end_p) + cx
        pxy(cn).Y = -r * Cos(end_p) + cy
        cn = cn + 1
        
        If start_p = 0 And end_p = PI * 2 Then
        Else
            pxy(cn).X = cx
            pxy(cn).Y = cy
            cn = cn + 1
        End If
        nPolyn(0) = cn
        Draw_Tile_and_Paint_and_Line pxy(), nPolyn(), 1, Tile, L, O_HDC, Size_mode


End Sub

Function Draw_DAEN(ByVal X, ByVal Y, ByVal XR, ByVal YR, ByVal Kakudo, _
             L As Line_Property, T As Tile_Property, ByVal Real_Circle_F As Boolean, ByVal O_HDC As Long, ByVal Size_mode As Integer) As Boolean
            

Dim f As Boolean, inf As Boolean
Dim C_Rect As RECT
Dim pxy() As POINTAPI, nPolyn(0) As Long
Dim w As Long, nPen As Long, n As Long


    If XR = 0 Or YR = 0 Then Exit Function
    
    If XR <> YR Or (TotalData.ViewStyle.ThreeDMode.Set3D_F = True And Real_Circle_F = False) Or _
        L.BasicLine.pattern = 1 Or L.CrossLine.XLine_f = True Or (T.TileCode <= 6) Then
    End If
    
    
    If XR = YR And (TotalData.ViewStyle.ThreeDMode.Set3D_F = False Or Real_Circle_F = True) And _
        L.BasicLine.pattern <> 1 And L.CrossLine.XLine_f = False And (T.TileCode = 7 Or T.TileCode = 8) Then
        'ȉ~^~œx^h肩󔒁A܂͓̏ꍇ
        With C_Rect
            .left = X - XR
            .top = Y - YR
            .right = X + XR
            .bottom = Y + YR
        End With
        If Size_mode = 0 Then
            If Compare_Two_Rectangle_Position_Long(C_Rect, TotalData.ScrData.MapScreen_Scale) = cstOuter Then
                Draw_DAEN = False
                Exit Function
            End If
        End If
        If L.BasicLine.pattern = 0 Then
            nPen = 0
        Else
            nPen = 5
        End If
        w = Get_Line_Width(L.BasicLine.SolidLine.Width, Size_mode)
        Select Case T.TileCode
            Case 7
                DrawEllipse X, Y, XR, Empty, L.BasicLine.SolidLine.Color, w, nPen, O_HDC
            Case 8
                DrawEllipse X, Y, XR, T.Line.BasicLine.SolidLine.Color, L.BasicLine.SolidLine.Color, w, nPen, O_HDC
        End Select
        inf = True
    Else
        '~̎̍WvZKv
        inf = Get_DAEN_Peri_XY(X, Y, XR, YR, Kakudo, Real_Circle_F, n, pxy(), Size_mode)
        If inf = True Then
            nPolyn(0) = n
            Draw_Tile_and_Paint_and_Line pxy(), nPolyn(), 1, T, L, O_HDC, Size_mode

        End If
    End If
    Draw_DAEN = inf
    
End Function
Private Function Get_DAEN_Peri_XY(ByVal X, ByVal Y, ByVal XR, ByVal YR, ByVal Kakudo, ByVal Real_Circle_F As Boolean, ByRef n As Long, pxy() As POINTAPI, ByVal Size_mode As Integer) As Boolean
'~̎̍WvZ()
Dim inf As Boolean
Dim f As Boolean, cn As Long
Dim ST As Single, p As Single
Dim ST2 As Single, ff As Boolean

    ST = 1 / ((XR + YR) / 5)
    cn = Int(6.28 / ST) + 5
    ReDim pxy(cn - 1)
    
    Get_DAEN_Peri_XY = False
    ff = True
    n = 0
    Do
        ST2 = n * ST
        f = Draw_DAEN_XY(ST2, X, Y, XR, YR, Kakudo, Real_Circle_F, n, pxy(), Size_mode)
        n = n + 1
        If f = True Then Get_DAEN_Peri_XY = True
    Loop While n * ST < 6.28
    pxy(n) = pxy(0)
    n = n + 1

End Function
Public Function Get_DAEN_IdoKedo(ByVal Kedo As Single, ByVal Ido As Single, ByVal XR As Single, ByVal YR As Single, ByVal Kakudo, ByRef n, pxy() As SingleXY) As Boolean
'ܓxox̉~̎̍WvZ(Px)
Dim inf As Boolean
Dim f As Boolean, cn As Long
Dim ST As Single, p As Single
Dim x2 As Single, y2 As Single

    
    ST = 1 / ((XR + YR) * 10)
    If ST > 0.2 Then
        ST = 0.2
    End If
    cn = Int(6.28 / ST) + 5
    ReDim pxy(cn - 1)
    
    n = 0
    For p = 0 To 6.28 Step ST
        x2 = Cos(p) * XR
        y2 = Sin(p) * YR
        Trans2D x2, y2, Kakudo
        x2 = x2 + Kedo
        y2 = -y2 + Ido
        pxy(n).X = x2
        pxy(n).Y = y2
        n = n + 1
    Next
    pxy(n) = pxy(0)
    n = n + 1
    Get_DAEN_IdoKedo = True

End Function

Private Function Draw_DAEN_XY(ByVal p As Single, ByVal X, ByVal Y, ByVal XR, ByVal YR, ByVal Kakudo, ByVal Real_Circle_F As Boolean, ByVal n, pxy() As POINTAPI, ByVal Size_mode As Integer) As Boolean
Dim x2 As Single, y2 As Single
Dim x3 As Single, y3 As Single

    If TotalData.ViewStyle.ThreeDMode.Set3D_F = True And Real_Circle_F = False And Size_mode = 0 Then
        x2 = Cos(p) * XR
        y2 = Sin(p) * YR
        Trans2D x2, y2, Kakudo
        x3 = x2 / TotalData.ScrData.ScreenMG.Mul + SRX(X)
        y3 = -y2 / TotalData.ScrData.ScreenMG.Mul + SRY(Y)
        Call Get_SxSy_With_3D(x3, y3, pxy(n).X, pxy(n).Y)
    Else
        x2 = Cos(p) * XR
        y2 = Sin(p) * YR
        Trans2D x2, y2, Kakudo
        x2 = x2 + X
        y2 = -y2 + Y
        pxy(n).X = x2
        pxy(n).Y = y2
    End If
    
    If Size_mode = 0 Then
        If Check_Point_in_screen(pxy(n).X, pxy(n).Y, 1) = True Then
            Draw_DAEN_XY = True
        End If
    Else
        Draw_DAEN_XY = True
    End If
End Function

Sub Mark_Print_Sample_Box(picMarkBox As PictureBox, MK As Mark_Property)
    
    With picMarkBox
    .AutoRedraw = True
    .Cls
    .ScaleMode = 3
    Mark_Print .ScaleWidth / 2, .ScaleHeight / 2, mn(.ScaleWidth, .ScaleHeight) * 0.4, MK, .hdc, 1
    .Refresh
    .AutoRedraw = False
    End With
End Sub

