VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "KJMap"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Enum Mask_Patern
    Or_Mask = 0
    And_Mask = 1
    No_Mask = 2
End Enum
Private Enum MapPosition_info
    BeforeWar = 0
    AfterWar = 1
    World = 2
End Enum
Private Enum Source_Info
    kokudotiriinn = 0
    Watizu = 1
    Orthophoto = 2
    Jinnsoku = 3
    Seisiki2Man = 4
    DensiKokudoOrtho = 5
End Enum



Private Type Gazo_PositionData_Info
    'Q}p
    Fname As String
    Box As IdoKedoFrame_Info
End Type

Private Type ZufukuInfo
    'Q}p
    Name As String
    Comment As String
    Box As IdoKedoFrame_Info
End Type

Private Type MapTime_Info
    FolderName As String
    Start As Long
    End As Long
    Legend_Number As Long
    Mask_Pattern As Mask_Patern
    expname As String
    GetDate As String
    MapPosition As MapPosition_info
    Source As Source_Info
    TikeizuZurekiNum As Long
    OrthoTime As Long
    EachFazoF As Boolean '摜XɈܓxoxݒ肵Ď擾iQj
    EachGazoNum As Long
    EachGazoData() As Gazo_PositionData_Info
    EachZufukuNum As Long
    EachZufukuData() As ZufukuInfo
End Type

Private Type KJMap_Info
    DataSetName As String
    DataSetFolder As String
    Zureki() As String
    title As String
    Read_F As Boolean
    Xpicsize As Long
    Ypicsize As Long
    Tikezu_XNum As Long
    Tikezu_YNum As Long
    XPicNum_perTikeizu As Long
    YPicNum_perTikeizu As Long
    Xnum As Long
    Ynum As Long
    Znum As Long
    Frame As IdoKedoFrame_Info
    Shonin_Map As String
    ZukakuMove(2) As POINTAPI
    TimeData() As MapTime_Info
    TikeizuNum As Long
    Watchizu_Num As Long
    DensiKokudoOrtho_Num As Long
    OrthoGetF As String
    JinnsokuF As String
    Seisiki2ManF As String
    Ortho_Num As Long
    Jinnsoku_Num As Long
End Type

Private Type KJMapDataSet_Info
    KJMap_Folder As String
    DataSet_Num As Long
    DataSet() As KJMap_Info
End Type

Dim KJMapDataSet As KJMapDataSet_Info

Private Type inifile_info
    Total As String
    Tikeizu As String
    Watizu As String
    DensiKokudOrtho As String
    Ortho As String
    Jinnsoku As String
    Zureki As String
    Seisiki2Man As String
    PositionRecord As String
    MarkFile As String
    GazoFileListFile As String
    DataURL As String
    PackDataServerListURL As String
    PackDataURL(5) As String
    PackDataURLNum As Long
End Type

Dim IniFile As inifile_info


Dim KJEnabled As String
Public Function Get_GazoFile_by_Rect(ByVal DataSetNum As Long, ByVal DataTime As Long, ByVal Ido1 As Single, ByVal Kedo1 As Single, ByVal Ido2 As Single, ByVal Kedo2 As Single) As String()
'ܓxox́AƕԂlƂɐEnn
Dim i As Long, j As Long
Dim n As Long
Dim ReturnData() As String, Folder As String
Dim SCBox As IdoKedoFrame_Info
Dim GazoBox As IdoKedoFrame_Info
Dim GazoSubBox As IdoKedoFrame_Info
Dim x2 As Double, y2 As Double
Dim TI As Long, tj As Long
Dim OneDataSetnum As Long
Dim f As Boolean, Fname As String

    OneDataSetnum = 10
    With SCBox
        .WestKedo = Kedo1
        .EastKedo = Kedo2
        .NorthIdo = Ido1
        .SouthIDo = Ido2
    End With
    
    ReDim ReturnData(0)
    
    With KJMapDataSet.DataSet(DataSetNum)
        Folder = KJMapDataSet.KJMap_Folder & "\" & .DataSetFolder & "\" & .TimeData(DataTime).FolderName
        Select Case .TimeData(DataTime).EachFazoF
            Case False 'n`}}sɐ؂Ă摜
                For i = 0 To .Tikezu_XNum * .XPicNum_perTikeizu - 1
                    TI = i \ .XPicNum_perTikeizu
                    GazoSubBox.WestKedo = .Frame.WestKedo + (i / .XPicNum_perTikeizu) * (7.5 / 60)
                    If .TimeData(DataTime).MapPosition = BeforeWar Then
                        GazoSubBox.WestKedo = GazoSubBox.WestKedo + (10.4 / 3600)
                    End If
                    GazoSubBox.EastKedo = GazoSubBox.WestKedo + (7.5 / 60) / .XPicNum_perTikeizu
                    For j = 0 To .Tikezu_YNum * .YPicNum_perTikeizu - 1
                        tj = j \ .YPicNum_perTikeizu
                        GazoSubBox.NorthIdo = .Frame.NorthIdo - (j / .YPicNum_perTikeizu) * (5 / 60)
                        GazoSubBox.SouthIDo = GazoSubBox.NorthIdo - (5 / 60) / .YPicNum_perTikeizu
                        With .TimeData(DataTime)
                            Select Case .MapPosition
                                Case BeforeWar, AfterWar
                                    '{nn̏ꍇ͐Ennɕϊ
                                    With GazoSubBox
                                        Call Tokyo97toITRF94(.NorthIdo, .WestKedo, y2, x2)
                                    End With
                                    GazoBox.WestKedo = CSng(x2)
                                    GazoBox.NorthIdo = CSng(y2)
                                    With GazoSubBox
                                        Call Tokyo97toITRF94(.SouthIDo, .EastKedo, y2, x2)
                                    End With
                                    GazoBox.EastKedo = CSng(x2)
                                    GazoBox.SouthIDo = CSng(y2)
                                Case World
                                    GazoBox = GazoSubBox
                            End Select
                            If Compare_Two_IdoKedoRectangle_Position_Single(GazoBox, SCBox) <> cstOuter Then
                                f = False
                                If .Source = kokudotiriinn Then
                                    'n`}̏ꍇ͐}`FbNėLmF
                                    If KJMapDataSet.DataSet(DataSetNum).Zureki(TI, tj, .TikeizuZurekiNum + 1, 0) <> "" Then
                                        f = True
                                        Fname = right$("00" & CStr(i), 3) & "_" & right$("00" & CStr(j), 3)
                                    End If
                                Else
                                    f = True
                                    Fname = right$("00" & CStr(i), 3) & "_" & right$("00" & CStr(j), 3)
                                End If
                                If f = True Then
                                    If UBound(ReturnData) < n * OneDataSetnum + OneDataSetnum Then
                                        ReDim Preserve ReturnData(n * OneDataSetnum + 10 * OneDataSetnum)
                                    End If
                                    ReturnData(n * OneDataSetnum) = Folder & "\" & Fname & "." & .expname
                                    ReturnData(n * OneDataSetnum + 1) = GazoBox.WestKedo
                                    ReturnData(n * OneDataSetnum + 2) = GazoBox.NorthIdo
                                    ReturnData(n * OneDataSetnum + 3) = GazoBox.EastKedo
                                    ReturnData(n * OneDataSetnum + 4) = GazoBox.SouthIDo
                                    If .Mask_Pattern = And_Mask Then
                                        ReturnData(n * OneDataSetnum + 5) = "AND"
                                        ReturnData(n * OneDataSetnum + 6) = Folder & "\M_" & Fname & "." & .expname
                                    Else
                                        ReturnData(n * OneDataSetnum + 5) = "COPY"
                                    End If
                                    If FileExists(ReturnData(n * OneDataSetnum)) = True Then
                                        ReturnData(n * OneDataSetnum + 7) = "EXIST"
                                    Else
                                        ReturnData(n * OneDataSetnum + 7) = "DOWNLOAD"
                                        ReturnData(n * OneDataSetnum + 8) = "http://ktgis.net/kjmap/" & _
                                            KJMapDataSet.DataSet(DataSetNum).DataSetFolder & "/" & .FolderName & "/" & _
                                            Fname & "." & .expname
                                        ReturnData(n * OneDataSetnum + 9) = "http://ktgis.net/kjmap/" & _
                                            KJMapDataSet.DataSet(DataSetNum).DataSetFolder & "/" & .FolderName & "/M_" & _
                                            Fname & "." & .expname
                                    End If
                                    n = n + 1
                                End If
                            End If
                        End With
                    Next
                Next
            Case True 'l̈ܓxox̃f[^ꍇ
                With .TimeData(DataTime)
                    For i = 0 To .EachGazoNum - 1
                        Select Case .MapPosition
                            Case BeforeWar, AfterWar
                                '{nn̏ꍇ͐Ennɕϊ
                                With .EachGazoData(i).Box
                                    Call Tokyo97toITRF94(.NorthIdo, .WestKedo, y2, x2)
                                End With
                                GazoBox.WestKedo = CSng(x2)
                                GazoBox.NorthIdo = CSng(y2)
                                With .EachGazoData(i).Box
                                    Call Tokyo97toITRF94(.SouthIDo, .EastKedo, y2, x2)
                                End With
                                GazoBox.EastKedo = CSng(x2)
                                GazoBox.SouthIDo = CSng(y2)
                            Case World
                                GazoBox = .EachGazoData(i).Box
                        End Select
                        
                        If Compare_Two_IdoKedoRectangle_Position_Single(GazoBox, SCBox) <> cstOuter Then
                            If UBound(ReturnData) < n * OneDataSetnum + OneDataSetnum Then
                                ReDim Preserve ReturnData(n * OneDataSetnum + 10 * OneDataSetnum)
                            End If
                            ReturnData(n * OneDataSetnum) = Folder & "\" & .EachGazoData(i).Fname
                            ReturnData(n * OneDataSetnum + 1) = GazoBox.WestKedo
                            ReturnData(n * OneDataSetnum + 2) = GazoBox.NorthIdo
                            ReturnData(n * OneDataSetnum + 3) = GazoBox.EastKedo
                            ReturnData(n * OneDataSetnum + 4) = GazoBox.SouthIDo
                            ReturnData(n * OneDataSetnum + 5) = "COPY"
                            If FileExists(ReturnData(n * OneDataSetnum)) = True Then
                                ReturnData(n * OneDataSetnum + 7) = "EXIST"
                            Else
                                ReturnData(n * OneDataSetnum + 7) = "DOWNLOAD"
                                ReturnData(n * OneDataSetnum + 8) = "http://ktgis.net/kjmap/" & _
                                    KJMapDataSet.DataSet(DataSetNum).DataSetFolder & "/" & .FolderName & "/" & _
                                    .EachGazoData(i).Fname
                            End If
                            n = n + 1
                        End If
                    Next
                End With
        End Select
    End With
    ReDim Preserve ReturnData(n * OneDataSetnum + OneDataSetnum - 1)
    Get_GazoFile_by_Rect = ReturnData
End Function

Public Function GetKJMapData(ByVal Folder As String) As Boolean
'̃}bvf[^tH_w肵Ď擾
Dim i As Long
        
        If FileExists(Folder & "\dataset.txt") Then
            With KJMapDataSet
                .KJMap_Folder = Folder
                Open .KJMap_Folder & "\dataset.txt" For Input As #1
                Input #1, .DataSet_Num
                ReDim .DataSet(.DataSet_Num - 1)
                For i = 0 To .DataSet_Num - 1
                    Input #1, .DataSet(i).DataSetName, .DataSet(i).DataSetFolder
                Next
                Close
            End With
            GetKJMapData = MapInit()
        Else
            GetKJMapData = False
        End If
    KJEnabled = GetKJMapData
End Function
Public Property Get Enabled() As Boolean
        Enabled = KJEnabled
End Property
Public Property Get DataSetNum() As Long
    DataSetNum = KJMapDataSet.DataSet_Num
End Property
Public Property Get DataSetName(ByVal DataSetNum As Long) As String
    DataSetName = KJMapDataSet.DataSet(DataSetNum).title
End Property
Public Property Get DataSetTimeNum(ByVal DataSetNum As Long) As Long
    DataSetTimeNum = KJMapDataSet.DataSet(DataSetNum).Znum
End Property
Public Property Get DataSetTimeTitle(ByVal DataSetNum As Long, ByVal Time As Long) As String
Dim a$

    With KJMapDataSet.DataSet(DataSetNum).TimeData(Time)
        a$ = Get_YearStr(.Start, .End, 0)
        Select Case .Source
            Case Watizu
                If .Start < 2011 Then
                    a$ = a$ & "iEHbj"
                Else
                    a$ = a$ & "idqy{}j"
                End If
            Case DensiKokudoOrtho
                a$ = a$ & "i󒆎ʐ^j"
            Case Orthophoto
                Select Case .OrthoTime
                    Case 4
                        a$ = a$ & "i3`4{{kЌj"
                    Case 5
                        a$ = a$ & "i5`6{kЌj"
                    Case Else
                        a$ = a$ & "i󒆎ʐ^j"
                End Select
            Case Jinnsoku
                a$ = a$ & "iv}j"
            Case Seisiki2Man
                a$ = a$ & "i1/2j"
        End Select
    End With
    DataSetTimeTitle = a$
    
End Property
Private Function Get_YearStr(ByVal startYear As Long, ByVal endYear As Long, ByVal KOYOMI As Long) As String
Dim a$, b$, c$
Dim Y1$, y2$

    Select Case KOYOMI
        Case 0
            Y1$ = CStr(startYear)
            y2$ = CStr(endYear)
            If Y1$ = y2$ Then
                a$ = Y1$ & "N"
            Else
                If left(Y1$, 2) = left(y2$, 2) Then
                    y2$ = Mid(y2$, 3)
                End If
                a$ = Y1$ & "-" & y2$ & "N"
            End If
        Case 1
            Y1$ = Get_Gengo(startYear)
            y2$ = Get_Gengo(endYear)
            If Y1$ = y2$ Then
                a$ = a$ & Y1$ & "N"
            Else
                If left(Y1$, 2) = left(y2$, 2) Then
                    y2$ = Mid(y2$, 3)
                End If
                a$ = a$ & Y1$ & "-" & y2$ & "N"
            End If
    End Select
    Get_YearStr = a$
End Function
Private Function Get_Gengo(ByVal Year As Long) As String
    If Year <= 1911 Then
        Get_Gengo = "" & CStr(Year - 1867)
    ElseIf Year <= 1925 Then
        Get_Gengo = "吳" & CStr(Year - 1900 - 11)
    ElseIf Year <= 1988 Then
        Get_Gengo = "a" & CStr(Year - 1900 - 25)
    Else
        Get_Gengo = "" & CStr(Year - 2000 + 12)
    End If
End Function

Private Function MapInit() As Boolean
'̃}bṽf[^t@Cǂݍ
Dim i As Long, j As Long, k As Long, f As Boolean
    
    Screen.MousePointer = 11
    MapInit = True
    For i = 0 To KJMapDataSet.DataSet_Num - 1
        f = init_map2(i)
        If f = False Then
            MapInit = False
            Exit For
        End If
    Next
    Screen.MousePointer = 0
End Function
Private Function init_map2(ByVal Dset As Long) As Boolean
Dim i As Long, j As Long, k As Long
Dim ifile$, a$, b$, c$, fi$, zu$
Dim DataFolder As String

    With KJMapDataSet.DataSet(Dset)
        DataFolder = KJMapDataSet.KJMap_Folder & "\" & .DataSetFolder
        ifile$ = DataFolder & IniFile.Total
        If FileExists(ifile$) = True Then
            Open ifile$ For Input As #1
            Do
                Input #1, a$
                i = InStr(a$, "=")
                If i = 0 Then
                Else
                    b$ = left$(a$, i - 1)
                    c$ = Mid$(a$, i + 1)
                    Select Case b$
                        Case "^Cg"
                            .title = c$
                        Case "摜"
                            .Xpicsize = Val(c$)
                        Case "摜"
                            .Ypicsize = Val(c$)
                        Case "n`}"
                            .Tikezu_XNum = Val(c$)
                        Case "cn`}"
                            .Tikezu_YNum = Val(c$)
                        Case "n`}P艡摜"
                            .XPicNum_perTikeizu = Val(c$)
                        Case "n`}Pc摜"
                            .YPicNum_perTikeizu = Val(c$)

                        Case "}s"
                             .ZukakuMove(MapPosition_info.BeforeWar).X = Val(c$)
                            Input #1, .ZukakuMove(MapPosition_info.BeforeWar).Y
                        Case "{nn}s"
                             .ZukakuMove(MapPosition_info.AfterWar).X = Val(c$)
                            Input #1, .ZukakuMove(MapPosition_info.AfterWar).Y
                        Case "Enn}s"
                             .ZukakuMove(MapPosition_info.World).X = Val(c$)
                            Input #1, .ZukakuMove(MapPosition_info.World).Y
                        Case "[ox"
                            .Frame.WestKedo = Val(c$)
                        Case "k[ܓx"
                            .Frame.NorthIdo = Val(c$)
                        Case "F"
                            .Shonin_Map = c$
                        Case "I\󒆎ʐ^"
                            If Len(c$) = 4 Then
                                c$ = c$ & "00"
                            ElseIf Len(c$) = 5 Then
                                c$ = c$ & "0"
                            End If
                            .OrthoGetF = c$
                        Case "v}"
                            .JinnsokuF = c$
                        Case ""
                            .Seisiki2ManF = c$
                    End Select
                End If
            Loop While EOF(1) = False
            Close
        
            .Xnum = .Tikezu_XNum * .XPicNum_perTikeizu
            .Ynum = .Tikezu_YNum * .YPicNum_perTikeizu
            With .Frame
                .SouthIDo = .NorthIdo - KJMapDataSet.DataSet(Dset).Tikezu_YNum * (5 / 60)
                .EastKedo = .WestKedo + KJMapDataSet.DataSet(Dset).Tikezu_XNum * (7.5 / 60)
            End With
        
        'n`}ǂݍ
            Open DataFolder & IniFile.Tikeizu For Input As #1
                Input #1, .TikeizuNum
                .Znum = .TikeizuNum
                ReDim .TimeData(.Znum - 1)
                For i = 0 To .TikeizuNum - 1
                    With .TimeData(i)
                        Input #1, .FolderName, .MapPosition, .Start, .End, .Mask_Pattern, .Legend_Number, .TikeizuZurekiNum, .expname
                        .Source = kokudotiriinn
                        .GetDate = ""
                        .EachFazoF = False
                    End With
                Next
            Close

            'n`}}ǂݍ
            ReDim .Zureki(.Tikezu_XNum - 1, .Tikezu_YNum, .TikeizuNum, 1)
            fi$ = DataFolder & IniFile.Zureki
            If FileExists(fi$) = True Then
                Open fi$ For Input As #1
                For i = 0 To .Tikezu_YNum - 1
                    For j = 0 To .TikeizuNum
                        For k = 0 To .Tikezu_XNum - 1
                            Input #1, zu$
                            .Zureki(k, i, j, 0) = zu$
                            Input #1, zu$
                            .Zureki(k, i, j, 1) = zu$
                        Next
                    Next
                Next
                Close
            End If
    
            'EHbǂݍ
            If FileExists(DataFolder & IniFile.Watizu) = True Then
                Open DataFolder & IniFile.Watizu For Input As #1
                Input #1, .Watchizu_Num
                j = .Znum
                .Znum = .Znum + .Watchizu_Num
                ReDim Preserve .TimeData(.Znum - 1)
                For i = 0 To .Watchizu_Num - 1
                    With .TimeData(i + j)
                        Input #1, .FolderName, .Start, .End, .GetDate
                        .Source = Watizu
                        .MapPosition = World
                        .Mask_Pattern = And_Mask
                        .TikeizuZurekiNum = -1
                        .expname = "png"
                        .EachFazoF = False
                    End With
                Next
                Close
            Else
                .Watchizu_Num = 0
            End If
            
            'dqy{}iI\摜jǂݍ
            If FileExists(DataFolder & IniFile.DensiKokudOrtho) = True Then
                Open DataFolder & IniFile.DensiKokudOrtho For Input As #1
                Input #1, .DensiKokudoOrtho_Num
                j = .Znum
                .Znum = .Znum + .DensiKokudoOrtho_Num
                ReDim Preserve .TimeData(.Znum - 1)
                For i = 0 To .DensiKokudoOrtho_Num - 1
                    With .TimeData(i + j)
                        Input #1, .FolderName, .Start, .End, .GetDate
                        .Source = DensiKokudoOrtho
                        .MapPosition = World
                        .Mask_Pattern = No_Mask
                        .TikeizuZurekiNum = -1
                        .expname = "jpg"
                        .EachFazoF = False
                    End With
                Next
                Close
            Else
                .DensiKokudoOrtho_Num = 0
            End If
        
            'I\摜ǂݍ
            If FileExists(DataFolder & IniFile.Ortho) = True Then
                Open DataFolder & IniFile.Ortho For Input As #1
                Input #1, .Ortho_Num
                j = .Znum
                .Znum = .Znum + .Ortho_Num
                ReDim Preserve .TimeData(.Znum - 1)
                For i = 0 To .Ortho_Num - 1
                    With .TimeData(i + j)
                        Input #1, .FolderName, .OrthoTime
                        Call Get_Ortho_Time(.OrthoTime, .Start, .End)
                        .Source = Orthophoto
                        .MapPosition = World
                        .Mask_Pattern = No_Mask
                        .TikeizuZurekiNum = -1
                        .expname = "jpg"
                        .EachFazoF = False
                    End With
                Next
                Close
            Else
                .Ortho_Num = 0
            End If
            
            If .JinnsokuF = "1" Then
                'v}ǂݍ
                If FileExists(DataFolder & IniFile.Jinnsoku) = True Then
                    Open DataFolder & IniFile.Jinnsoku For Input As #1
                    Input #1, .Jinnsoku_Num
                    If .Jinnsoku_Num = 1 Then
                        j = .Znum
                        .Znum = .Znum + .Jinnsoku_Num
                        ReDim Preserve .TimeData(.Znum - 1)
                        With .TimeData(j)
                             .FolderName = "JINNSOKU"
                            .Start = 1880
                            .End = 1885
                            .Source = Jinnsoku
                            .MapPosition = World
                            .Mask_Pattern = No_Mask
                            .TikeizuZurekiNum = -1
                            .expname = "jpg"
                            .EachFazoF = False
    
                        End With
                    End If
                    Close
                Else
                    .Jinnsoku_Num = 0
                End If
            End If
            
            'Qǂݍ
            If .Seisiki2ManF = "1" Then
                Open DataFolder & IniFile.Seisiki2Man For Input As #1
                j = .Znum
                .Znum = .Znum + 1
                ReDim Preserve .TimeData(.Znum - 1)
                With .TimeData(j)
                    .EachFazoF = True
                    .FolderName = "2man"
                    .Source = Seisiki2Man
                    .Mask_Pattern = Or_Mask
                    .TikeizuZurekiNum = -1
                    .expname = "png"
                    .MapPosition = BeforeWar
    
                    Input #1, .Start, .End
                    Input #1, .EachGazoNum, .EachZufukuNum
                    ReDim .EachGazoData(.EachGazoNum - 1)
                    ReDim .EachZufukuData(.EachZufukuNum - 1)
                    Line Input #1, a$
                    For i = 0 To .EachGazoNum - 1
                        With .EachGazoData(i)
                            Input #1, .Fname
                            With .Box
                                Input #1, .WestKedo, .EastKedo, .NorthIdo, .SouthIDo
                            End With
                        End With
                    Next
                    Line Input #1, a$
                    For i = 0 To .EachZufukuNum - 1
                        With .EachZufukuData(i)
                            With .Box
                                Input #1, .WestKedo, .EastKedo, .NorthIdo, .SouthIDo
                            End With
                            Input #1, .Name, .Comment
                        End With
                    Next
                End With
                Close
            End If
            
            Call TimeSorting(Dset)
    
            
            .Read_F = True
            init_map2 = True
    
    
        Else
            init_map2 = False
            .Read_F = False
        End If
    End With
    
End Function
Private Sub Get_Ortho_Time(ByVal Time As Long, ByRef StartTime As Long, ByRef EndTime As Long)
    Select Case Time
        Case 0
            StartTime = 1974
            EndTime = 1978
        Case 1
            StartTime = 1979
            EndTime = 1983
        Case 2
            StartTime = 1984
            EndTime = 1986
        Case 3
            StartTime = 1987
            EndTime = 1990
        Case 4
            StartTime = 2011
            EndTime = 2011
        Case 5
            StartTime = 2011
            EndTime = 2011
    End Select
End Sub
Private Sub TimeSorting(ByVal Dset As Long)
'ԏɕׂ
Dim i As Long
Dim TSort As SortingSearch
Dim Tpush() As MapTime_Info

    Set TSort = New SortingSearch
    TSort.AddInit vbLong
    With KJMapDataSet.DataSet(Dset)
        For i = 0 To .Znum - 1
            TSort.AddLong KJMapDataSet.DataSet(Dset).TimeData(i).Start
        Next
        TSort.AddEnd
        Tpush = .TimeData
        
        For i = 0 To .Znum - 1
            .TimeData(i) = Tpush(TSort.DataPosition(i))
        Next
    End With

End Sub
Private Sub Class_Initialize()
    With IniFile
        .Total = "\mapinfo.txt"
        .Tikeizu = "\map_tikeizu_info.txt"
        .Zureki = "\}.csv"
        .Watizu = "\map_watizu_info.txt"
        .Ortho = "\map_ortho_info.txt"
        .DensiKokudOrtho = "\map_densikokudo_ortho_info.txt"
        .Jinnsoku = "\map_Jinnsoku_info.txt"
        .Seisiki2Man = "\map_2man_info.txt"
        .PositionRecord = "\PositionRecored.txt"
        .MarkFile = "\MarkData.kmk"
        .GazoFileListFile = "\gazo_check_list.txt"
        .DataURL = "http://ktgis.net/kjmap/" 'ړȂ\̃T[o[
    End With
    KJEnabled = False
End Sub
