VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSpatialIndexSearch"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Enum Add_or_Remove
    Add_Obj = 1
    Remove_Obj = 2
End Enum

Private Type Object_Info
    ObjectNumber As Long 'bṼIuWFNgԍ
    ObjectPointNumber As Long 'IuWFNg̃|Cgԍ
End Type

Private Type IndexContents_Info
    Num As Long 'bṼIuWFNg
    ObjectNumber() As Object_Info
End Type
Dim MeshIndex() As IndexContents_Info
Dim XYSize As Long
Dim meshw  As Single
Dim meshh As Single

Private Type ObjectXY_Info
    Pnum As Long
    Point() As SingleXY
    Tag As Long
    RemoveF As Boolean
End Type
Dim ObjectXY() As ObjectXY_Info

Dim ObjectType As SpatialPointType


Dim MeshRect  As Box_Data
Dim RectSetF As Boolean
Dim AddEndF As Boolean

Dim ObjectNum As Long
Dim ExtraRange As Single
Dim ExtraRangeF As Boolean

Dim LineCutNum As Long

Public Sub Init(ByVal ObjType As SpatialPointType, ByVal ExtraRangeFlag As Boolean, _
        Optional ByVal X1 As Single = 0, Optional ByVal Y1 As Single = 0, Optional ByVal x2 As Single = 0, Optional ByVal y2 As Single = 0, _
        Optional ByVal ExtraRange_Size As Single = 0)
'\bh
'X1Y1Ŝ̑傫Bȗꍇ͂ƂŌvZ

    ObjectType = ObjType
    ObjectNum = 0
    ReDim ObjectXY(100)
    ExtraRange = ExtraRange_Size
    ExtraRangeF = ExtraRangeFlag
    
    If X1 = 0 And x2 = 0 And Y1 = 0 And y2 = 0 Then
        RectSetF = False
    Else
        With MeshRect
            .left = mn(X1, x2) - ExtraRange
            .right = mx(X1, x2) + ExtraRange
            .top = mn(Y1, y2) - ExtraRange
            .bottom = mx(Y1, y2) + ExtraRange
        End With
        RectSetF = True
    End If
    AddEndF = False
End Sub
Private Sub BoxData_AddExtraRange(PBox As Box_Data)
'lp`ɕvX
    With PBox
        .left = .left - ExtraRange
        .right = .right + ExtraRange
        .top = .top - ExtraRange
        .bottom = .bottom + ExtraRange
    End With

End Sub
Public Sub AddEnd()
'|Cg̒ǉIăbVɔz
Dim i As Long, j As Long, n As Long

    If ObjectNum = 0 Then
        Exit Sub
    End If
    
    n = 0
    For i = 0 To ObjectNum - 1
        n = n + ObjectXY(i).Pnum
    Next
    Select Case ObjectType
        Case SpatialPointType.SinglePoint
            XYSize = Int(Sqr(n))
            If ExtraRange = 0 Then
                XYSize = XYSize * 2
            End If
        Case SpatialPointType.SPILine
            XYSize = Int(Sqr(n) / 8)
            LineCutNum = Int((n / ObjectNum))
            LineCutNum = mx(LineCutNum, 50)
        Case SpatialPointType.SPIRect
            XYSize = Int(Sqr(n))
    End Select
    XYSize = mx(XYSize, 2)
    
    ReDim MeshIndex(XYSize, XYSize)


    If RectSetF = False Then
        'lɑ傫w肵ĂȂꍇ͂Œǉ
        With MeshRect
            .left = ObjectXY(0).Point(0).X
            .right = .left
            .top = ObjectXY(0).Point(0).Y
            .bottom = .top
        End With
        For i = 0 To ObjectNum - 1
            With ObjectXY(i)
                For j = 0 To .Pnum - 1
                    With .Point(j)
                    Call Get_Circumscribed_Rectangle(.X, .Y, MeshRect)
                    End With
                Next
            End With
        Next
        Call BoxData_AddExtraRange(MeshRect)
    End If
    
    With MeshRect
        If CDec(.right) = CDec(.left) Then
            meshw = 1
        Else
            meshw = (.right - .left) / XYSize
        End If
        If CDec(.top) = CDec(.bottom) Then
            meshh = 1
        Else
            meshh = (.bottom - .top) / XYSize
        End If
    End With
    If ExtraRange > mn(meshw, meshh) Then
        ExtraRange = mn(meshw, meshh)
    End If
    For i = 0 To ObjectNum - 1
        If ObjectXY(i).RemoveF = False Then
            Select Case ObjectType
                Case SpatialPointType.SinglePoint
                    Call AddMeshPoint(i, Add_Obj)
                Case SpatialPointType.SPILine
                    Call AddMeshLine(i)
                Case SpatialPointType.SPIRect
                    Call AddMeshRect(i, Add_Obj)
            End Select
        End If
    Next
    AddEndF = True
End Sub
Public Sub Refresh()
    RectSetF = False
    Call AddEnd
End Sub
Private Sub AddMeshLine(ByVal ObjNum As Long)
Dim i As Long
    
    For i = 0 To ObjectXY(ObjNum).Pnum - 1 Step LineCutNum
        Call Add_Mesh_LineSub(ObjNum, i, Add_Obj)
    Next
End Sub
Private Sub Add_Mesh_LineSub(ByVal ObjNum As Long, ByVal StartP As Long, ByVal AddorRemove As Add_or_Remove)
Dim PBox As Box_Data
Dim i As Long, j As Long
Dim RBox As RECT
Dim ex As Long, f As Boolean
    
    ex = StartP + LineCutNum
    If ObjectXY(ObjNum).Pnum < ex Then
        ex = ObjectXY(ObjNum).Pnum
    End If
    
    With PBox
        .left = ObjectXY(ObjNum).Point(StartP).X
        .right = .left
        .top = ObjectXY(ObjNum).Point(StartP).Y
        .bottom = .top
    End With
    
    For i = StartP To ex - 1
        With ObjectXY(ObjNum).Point(i)
            Call Get_Circumscribed_Rectangle(.X, .Y, PBox)
        End With
    Next
    Call BoxData_AddExtraRange(PBox)
    f = GetRangeXY(PBox, RBox)
    If f = True Then
        With RBox
            For i = .left To .right
                For j = .top To .bottom
                    If AddorRemove = Add_or_Remove.Add_Obj Then
                        Call Add_Mesh_PointSub(i, j, ObjNum, StartP)
                    Else
                        Call RemoveObject_sub(i, j, ObjNum)
                    End If
                Next
            Next
        End With
    End If

End Sub
Private Sub AddMeshRect(ByVal ObjNum As Long, ByVal AddorRemove As Add_or_Remove)
Dim PBox As Box_Data
Dim RBox As RECT, f As Boolean, i As Long, j As Long
    PBox = Get_TwoPoint_Rect_Single(ObjectXY(ObjNum).Point(0), ObjectXY(ObjNum).Point(1))
    Call BoxData_AddExtraRange(PBox)
    f = GetRangeXY(PBox, RBox)
    If f = True Then
        With RBox
            For i = .left To .right
                For j = .top To .bottom
                    If AddorRemove = Add_or_Remove.Add_Obj Then
                        Call Add_Mesh_PointSub(i, j, ObjNum, 0)
                    Else
                        Call RemoveObject_sub(i, j, ObjNum)
                    End If
                Next
            Next
        End With
    End If
End Sub
Private Sub AddMeshPoint(ByVal ObjNum As Long, ByVal AddorRemove As Add_or_Remove)
Dim X As Long, Y As Long
Dim PBox As Box_Data
Dim X1 As Long, x2 As Long, Y1 As Long, y2 As Long
Dim i As Long, j As Long, k As Long
Dim RBox As RECT, exf As Boolean

    For k = 0 To ObjectXY(ObjNum).Pnum - 1
        If ExtraRangeF = False Then
            '傫̂Ȃ|Cgǉ
            exf = GetConPointXY(ObjectXY(ObjNum).Point(k), X, Y)
            If exf = True Then
                If AddorRemove = Add_or_Remove.Add_Obj Then
                    Call Add_Mesh_PointSub(X, Y, ObjNum, k)
                Else
                    Call RemoveObject_sub(X, Y, ObjNum)
                End If
            End If
        Else
            '傫̂|Cgǉ
            exf = GetExtraRange_XY(ObjectXY(ObjNum).Point(k), RBox)
            If exf = True Then
                With RBox
                    For i = .left To .right
                        For j = .top To .bottom
                            If AddorRemove = Add_or_Remove.Add_Obj Then
                                Call Add_Mesh_PointSub(i, j, ObjNum, k)
                            Else
                                Call RemoveObject_sub(i, j, ObjNum)
                            End If
                        Next
                    Next
                End With
            End If
        End If
    Next
End Sub
Private Sub Add_Mesh_PointSub(ByVal X As Long, ByVal Y As Long, ByVal ObjNum As Long, ByVal Pointnum As Long)
    With MeshIndex(X, Y)
        If .Num = 0 Then
            ReDim .ObjectNumber(5)
        Else
            If UBound(.ObjectNumber) < .Num Then
                ReDim Preserve .ObjectNumber(.Num + 5)
            End If
        End If
        With .ObjectNumber(.Num)
            .ObjectNumber = ObjNum
            .ObjectPointNumber = Pointnum
        End With
        .Num = .Num + 1
    End With
End Sub
Private Function GetConPointXY(inXY As SingleXY, ByRef X As Long, ByRef Y As Long) As Boolean
'bV̈ɓ邩`FbN
    With inXY
        X = Int((.X - MeshRect.left) / meshw)
        Y = Int((.Y - MeshRect.top) / meshh)
    End With
    If X < 0 Or Y < 0 Or X > XYSize Or Y > XYSize Then
        GetConPointXY = False
    Else
        GetConPointXY = True
    End If
End Function
Private Function GetExtraRange_XY(XY As SingleXY, OutPutRect As RECT) As Boolean
Dim PBox As Box_Data
    With XY
        PBox.left = .X - ExtraRange
        PBox.right = .X + ExtraRange
        PBox.top = .Y - ExtraRange
        PBox.bottom = .Y + ExtraRange
    End With
    GetExtraRange_XY = GetRangeXY(PBox, OutPutRect)
End Function
Private Function GetRangeXY(InPBox As Box_Data, OutRBox As RECT) As Boolean
Dim X1 As Long, x2 As Long, Y1 As Long, y2 As Long
    If Compare_Two_Rectangle_Position_Single(InPBox, MeshRect) <> cstOuter Then
        With InPBox
            X1 = Int((.left - MeshRect.left) / meshw)
            Y1 = Int((.top - MeshRect.top) / meshh)
            X1 = m_min_max(X1, 0, XYSize)
            Y1 = m_min_max(Y1, 0, XYSize)
            x2 = Int((.right - MeshRect.left) / meshw)
            y2 = Int((.bottom - MeshRect.top) / meshh)
            x2 = m_min_max(x2, 0, XYSize)
            y2 = m_min_max(y2, 0, XYSize)
        End With
        With OutRBox
            .left = X1
            .right = x2
            .top = Y1
            .bottom = y2
        End With
        GetRangeXY = True
    Else
        GetRangeXY = False
    End If
End Function
Private Sub Add_Point_Sub(ByVal Pnum As Long, XY() As SingleXY, ByVal TagData As Long)
Dim i As Long
    
    If UBound(ObjectXY) < ObjectNum Then
        ReDim Preserve ObjectXY(ObjectNum + 50)
    End If
    
    With ObjectXY(ObjectNum)
        .Pnum = Pnum
        .Tag = TagData
        .Point() = XY()
        
    End With
    If AddEndF = True Then
        'bV쐬ɒǉꍇ
        Select Case ObjectType
            Case SpatialPointType.SinglePoint
                Call AddMeshPoint(ObjectNum, Add_or_Remove.Add_Obj)
            Case SpatialPointType.SPILine
                Call AddMeshLine(ObjectNum)
            Case SpatialPointType.SPIRect
                Call AddMeshRect(ObjectNum, Add_or_Remove.Add_Obj)
        End Select
    End If
    ObjectNum = ObjectNum + 1
End Sub
Friend Sub AddMultiPoint(ByVal Pnum As Long, XY() As SingleXY, ByVal TagData As Long)
'n_IuWFNgǉ
    If ObjectType <> SpatialPointType.SinglePoint Then
        MsgBox "_ȊO͂ł܂B", vbExclamation
        Exit Sub
    End If
    Call Add_Point_Sub(Pnum, XY(), TagData)
    
    
End Sub
Friend Sub AddDoublePoint(XY1 As SingleXY, XY2 As SingleXY, ByVal TagData As Long)
Dim XY() As SingleXY
'2n_IuWFNgǉ

    If ObjectType <> SpatialPointType.SinglePoint Then
        MsgBox "_ȊO͂ł܂B", vbExclamation
        Exit Sub
    End If
    ReDim XY(1)
    XY(0) = XY1
    XY(1) = XY2
    Call Add_Point_Sub(2, XY(), TagData)
    
End Sub

Friend Sub AddSinglePoint(XY As SingleXY, ByVal TagData As Long)
Dim XY2() As SingleXY
'1n_IuWFNgǉ

    If ObjectType <> SpatialPointType.SinglePoint Then
        MsgBox "_ȊO͂ł܂B", vbExclamation
        Exit Sub
    End If
    ReDim XY2(0)
    XY2(0) = XY
    Call Add_Point_Sub(1, XY2(), TagData)
    
End Sub
Friend Sub AddSinglePoint_Allay(ByVal Num As Long, XY() As SingleXY, ByVal TagData As Long)
'1n_IuWFNgzŒǉ
Dim i As Long
Dim XYS() As SingleXY

    If ObjectType <> SpatialPointType.SinglePoint Then
        MsgBox "_ȊO͂ł܂B", vbExclamation
        Exit Sub
    End If
    
    ReDim XYS(0)
    
    For i = 0 To Num - 1
        XYS(0) = XY(i)
        Call Add_Point_Sub(1, XYS(), TagData)
    Next
    
End Sub

Public Function GetSamePointNumber(ByVal X As Single, ByVal Y As Single, ByRef PointNumber As Long, ByRef Tag As Long) As Long
'n_߁AԍԂ ݂Ȃꍇ-1Ԃ

Dim sx As Long, sy As Long, np As Long
Dim i As Long, gn As Long, n As Long, tg As Long
Dim exf As Boolean, XY As SingleXY
    
    If ObjectType <> SpatialPointType.SinglePoint Then
        MsgBox "_ȊO͂ł܂B", vbExclamation
        Exit Function
    End If
    If ExtraRangeF = True Then
        MsgBox "GetSamePointNumber͑傫̂|Cgɂ͎Ă܂B"
        Exit Function
    End If
    
    If ObjectNum = 0 Then
        GetSamePointNumber = -1
        Exit Function
    End If
    
    XY.X = X
    XY.Y = Y
    exf = GetConPointXY(XY, sx, sy)
    If exf = False Then
        GetSamePointNumber = -1
        Exit Function
    End If
    gn = -1
    With MeshIndex(sx, sy)
        For i = 0 To .Num - 1
            n = .ObjectNumber(i).ObjectNumber
            np = .ObjectNumber(i).ObjectPointNumber
            With ObjectXY(n).Point(np)
                If .X = X Then
                    If .Y = Y Then
                        gn = n
                        PointNumber = np
                        Tag = ObjectXY(n).Tag
                        i = MeshIndex(sx, sy).Num
                    End If
                End If
            End With
        Next
    End With
    GetSamePointNumber = gn
End Function
Public Function GetSamePointNumberAlley(ByVal X As Single, ByVal Y As Single, ByRef ObjNumber() As Long, ByRef PNumber() As Long, ByRef Tags() As Long) As Long
'n_߁AԍԂ ݂Ȃꍇ-1Ԃ

Dim sx As Long, sy As Long, np As Long
Dim i As Long, n As Long, tg As Long
Dim exf As Boolean, XY As SingleXY
Dim obn As Long

    If ObjectType <> SpatialPointType.SinglePoint Then
        MsgBox "_ȊO͂ł܂B", vbExclamation
        Exit Function
    End If
    If ExtraRangeF = True Then
        MsgBox "GetSamePointNumber͑傫̂|Cgɂ͎Ă܂B"
        Exit Function
    End If
    
    If ObjectNum = 0 Then
        GetSamePointNumberAlley = -1
        Exit Function
    End If
       
    XY.X = X
    XY.Y = Y
    exf = GetConPointXY(XY, sx, sy)
    If exf = False Then
        GetSamePointNumberAlley = -1
        Exit Function
    End If
    obn = 0
    With MeshIndex(sx, sy)
        If .Num > 0 Then
            ReDim ObjNumber(.Num - 1)
            ReDim Tags(.Num - 1)
            ReDim PNumber(.Num - 1)
            For i = 0 To .Num - 1
                n = .ObjectNumber(i).ObjectNumber
                np = .ObjectNumber(i).ObjectPointNumber
                With ObjectXY(n).Point(np)
                    If .X = X Then
                        If .Y = Y Then
                            ObjNumber(obn) = n
                            PNumber(obn) = np
                            Tags(obn) = ObjectXY(n).Tag
                            obn = obn + 1
                        End If
                    End If
                End With
            Next
        End If
    End With
    GetSamePointNumberAlley = obn
End Function
Public Function GetNearestLineNumber(ByVal X As Single, ByVal Y As Single, ByVal BaseDistance As Single, ByRef PointNumber As Long, _
            ByRef Tag As Long, Optional ByRef Distance As Single, Optional ByRef NearestPX As Single, Optional ByRef NearestPY As Single) As Long
Dim sx As Long, sy As Long, np As Long
Dim exf As Boolean, XY As SingleXY
Dim mind As Single, D As Single
Dim SP As Long, EP As Long, Onum As Long
Dim NearP As SingleXY, Near1P As SingleXY, NearObjNum As Long, NearObjPoint As Long
Dim i As Long, j As Long

    If ObjectType <> SpatialPointType.SPILine Then
        MsgBox "_ȊO͂ł܂B", vbExclamation
        Exit Function
    End If
    If ObjectNum = 0 Then
        GetNearestLineNumber = -1
        Exit Function
    End If
    
    If ObjectNum = 0 Then
        GetNearestLineNumber = -1
        Exit Function
    End If
    
    XY.X = X
    XY.Y = Y
    exf = GetConPointXY(XY, sx, sy)
    If exf = False Then
        GetNearestLineNumber = -1
        Exit Function
    End If
    
    mind = mn(ExtraRange, BaseDistance)
    NearObjNum = -1
    With MeshIndex(sx, sy)
        For i = 0 To .Num - 1
            Onum = .ObjectNumber(i).ObjectNumber
            SP = .ObjectNumber(i).ObjectPointNumber
            EP = SP + LineCutNum
            If ObjectXY(Onum).Pnum < EP Then
                EP = ObjectXY(Onum).Pnum
            End If
            With ObjectXY(Onum)
            For j = SP To EP - 2
                D = Distance_PointLine(X, Y, .Point(j).X, .Point(j).Y, .Point(j + 1).X, .Point(j + 1).Y, NearP.X, NearP.Y)
                If D < mind Then
                    mind = D
                    Near1P = NearP
                    NearObjNum = Onum
                    NearObjPoint = j
                End If
            Next
            End With
        Next
    End With
    GetNearestLineNumber = NearObjNum
    If NearObjNum <> -1 Then
        PointNumber = NearObjPoint
        Tag = ObjectXY(NearObjNum).Tag
        Distance = D
        NearestPX = Near1P.X
        NearestPY = Near1P.Y
    End If
End Function
Public Function GetNearestPointNumber(ByVal X As Single, ByVal Y As Single, ByVal BaseDistance As Single, ByRef Onumber() As Long, ByRef PNumber() As Long, ByRef Tags() As Long, _
                        Optional ByVal ExceptionNumber As Long = -1, Optional ByVal ExceptionTag As Variant = Empty) As Long
'ł߂n_߁AƔԍizjԂiój ݂Ȃꍇ-1Ԃ

Dim i As Long, n As Long
Dim sx As Long, sy As Long, np As Long
Dim ObStac() As Long, PStac() As Long
Dim same_N As Long, D As Single
Dim o_mind As Single, mind As Single
Dim exf As Boolean, XY As SingleXY
    
    If ObjectType <> SpatialPointType.SinglePoint Then
        MsgBox "_ȊO͂ł܂B", vbExclamation
        Exit Function
    End If
    
    If ExtraRangeF = False Then
        MsgBox "GetSamePointNumber͑傫̂Ȃ|Cgɂ͎Ă܂B"
        Exit Function
    End If
    
    If ObjectNum = 0 Then
        GetNearestPointNumber = 0
        Exit Function
    End If
        
    XY.X = X
    XY.Y = Y
    exf = GetConPointXY(XY, sx, sy)
    If exf = False Then
        GetNearestPointNumber = 0
        Exit Function
    End If
    
    mind = mn(ExtraRange, BaseDistance)
    o_mind = mind - 1
    same_N = 0
    With MeshIndex(sx, sy)
        For i = 0 To .Num - 1
            n = .ObjectNumber(i).ObjectNumber
            np = .ObjectNumber(i).ObjectPointNumber
            If n <> ExceptionNumber And (ObjectXY(n).Tag <> ExceptionTag Or ExceptionTag = Empty) Then
                With ObjectXY(n).Point(np)
                    D = Distance(X, Y, .X, .Y)
                    If D <= mind Then
                        If D = o_mind Then
                            ReDim Preserve ObStac(same_N)
                            ReDim Preserve PStac(same_N)
                        Else
                            same_N = 0
                            ReDim ObStac(same_N)
                            ReDim PStac(same_N)
                        End If
                        ObStac(same_N) = n
                        PStac(same_N) = np
                        same_N = same_N + 1
                        mind = D
                        o_mind = mind
                    End If
                End With
            End If
        Next
    End With
    Onumber = ObStac
    PNumber = PStac
    ReDim Tags(same_N)
    For i = 0 To same_N - 1
        Tags(i) = ObjectXY(ObStac(i)).Tag
    Next
    GetNearestPointNumber = same_N
End Function
Public Function GetRectIn(ByVal X As Single, ByVal Y As Single, ByRef Onumber() As Long, ByRef Tags() As Long) As Long
'w肵_lp̈擾
Dim exf As Boolean, XY As SingleXY
Dim PBox As Box_Data
Dim sx As Long, sy As Long, same_N As Long
Dim i As Long, n As Long
Dim ObStac() As Long

    If ObjectType <> SpatialPointType.SPIRect Then
        MsgBox "lpȊO͂ł܂B", vbExclamation
        Exit Function
    End If
    
    
    If ObjectNum = 0 Then
        GetRectIn = 0
        Exit Function
    End If
    
    XY.X = X
    XY.Y = Y
    exf = GetConPointXY(XY, sx, sy)
    If exf = False Then
        GetRectIn = 0
        Exit Function
    End If

    same_N = 0
    ReDim ObStac(same_N)
    With MeshIndex(sx, sy)
        For i = 0 To .Num - 1
            n = .ObjectNumber(i).ObjectNumber
            With ObjectXY(n)
                PBox = Get_TwoPoint_Rect_Single(.Point(0), .Point(1))
                If Check_PointInBox(X, Y, 0, PBox) = True Then
                    ReDim Preserve ObStac(same_N)
                    ObStac(same_N) = n
                    same_N = same_N + 1
                End If
            End With
        Next
    End With
    Onumber = ObStac
    ReDim Tags(same_N)
    For i = 0 To same_N - 1
        Tags(i) = ObjectXY(ObStac(i)).Tag
    Next
    GetRectIn = same_N

End Function
Friend Function GetRectOverlap(XY1 As SingleXY, XY2 As SingleXY, ByRef Onumber() As Long, ByRef Tags() As Long) As Long
'w肵̈ƏdȂlp̈擾
Dim f As Boolean, XY As SingleXY
Dim Q2box As RECT
Dim PBox As Box_Data, QBox As Box_Data
Dim sx As Long, sy As Long, same_N As Long
Dim i As Long, n As Long
Dim OSub() As Boolean
Dim ObStac() As Long

    If ObjectType <> SpatialPointType.SPIRect Then
        MsgBox "lpȊO͂ł܂B", vbExclamation
        Exit Function
    End If
    
    If ObjectNum = 0 Then
        GetRectOverlap = 0
        Exit Function
    End If
        
        
    QBox = Get_TwoPoint_Rect_Single(XY1, XY2)
    f = GetRangeXY(QBox, Q2box)
    
    If f = False Then
        GetRectOverlap = 0
        Exit Function
    End If

    ReDim OSub(ObjectNum - 1)
    same_N = 0
    ReDim ObStac(same_N)
    With Q2box
    For sx = .left To .right
        For sy = .top To .bottom
            With MeshIndex(sx, sy)
                For i = 0 To .Num - 1
                    n = .ObjectNumber(i).ObjectNumber
                    If OSub(n) = False Then
                        With ObjectXY(n)
                            OSub(n) = True
                            PBox = Get_TwoPoint_Rect_Single(.Point(0), .Point(1))
                            If Compare_Two_Rectangle_Position_Single(QBox, PBox) <> cstOuter Then
                                ReDim Preserve ObStac(same_N)
                                ObStac(same_N) = n
                                same_N = same_N + 1
                            End If
                        End With
                    End If
                Next
            End With
        Next
    Next
    End With
    Onumber = ObStac
    ReDim Tags(same_N)
    For i = 0 To same_N - 1
        Tags(i) = ObjectXY(ObStac(i)).Tag
    Next
    GetRectOverlap = same_N

End Function

Public Sub RemoveObject(ByVal Number As Long)
'w肵IuWFNgԍCfbNX폜
Dim i As Long, j As Long, k As Long
Dim X As Long, Y As Long
Dim RBox As RECT, exf As Boolean

    ObjectXY(Number).RemoveF = True
    Select Case ObjectType
        Case SpatialPointType.SinglePoint
            Call AddMeshPoint(Number, Remove_Obj)
        Case SpatialPointType.SPILine
            For i = 0 To ObjectXY(Number).Pnum - 1 Step LineCutNum
                Call Add_Mesh_LineSub(Number, i, Remove_Obj)
            Next
        Case SpatialPointType.SPIRect
            Call AddMeshRect(Number, Remove_Obj)
    End Select
End Sub
Private Sub RemoveObject_sub(ByVal X As Long, ByVal Y As Long, ByVal Number As Long)
Dim i As Long, j As Long

    With MeshIndex(X, Y)
        i = 0
        Do Until .ObjectNumber(i).ObjectNumber = Number
            i = i + 1
        Loop
        For j = i + 1 To .Num - 1
            .ObjectNumber(j - 1) = .ObjectNumber(j)
        Next
        .Num = .Num - 1
    End With

End Sub

Public Sub RemoveObject_byTag(ByVal TagNumber As Long)
'w肵^ÕIuWFNǧCfbNX폜
Dim i As Long
        
    For i = 0 To ObjectNum - 1
        If ObjectXY(i).Tag = TagNumber Then
            If ObjectXY(i).RemoveF = False Then
                Call RemoveObject(i)
            End If
        End If
    Next
End Sub
Friend Sub AddLine(ByVal Pnum As Long, XY() As SingleXY, ByVal TagData As Long)
'IuWFNgǉ
Dim i As Long, n As Long

    If ObjectType <> SpatialPointType.SPILine Then
        MsgBox "ȊO͂ł܂B", vbExclamation
        Exit Sub
    End If
    
    Call Add_Point_Sub(Pnum, XY, TagData)
    
End Sub
Public Sub ChangeTagValue(ByVal ChangeValue As Long, ByVal StartRangeValue As Long, ByVal LastRangeValue As Long)
'^O̒lω
Dim i As Long
        
    For i = 0 To ObjectNum - 1
        If Check_Two_Value_In(ObjectXY(i).Tag, StartRangeValue, LastRangeValue) <> chvOuter Then
            ObjectXY(i).Tag = ObjectXY(i).Tag + ChangeValue
        End If
    Next

End Sub
Friend Sub AddRect(XY1 As SingleXY, XY2 As SingleXY, ByVal TagData As Long)
Dim XY() As SingleXY
'lpIuWFNgǉ

    If ObjectType <> SpatialPointType.SPIRect Then
        MsgBox "lpȊO͂ł܂B", vbExclamation
        Exit Sub
    End If
    ReDim XY(1)
    XY(0) = XY1
    XY(1) = XY2
    Call Add_Point_Sub(2, XY(), TagData)
    
End Sub
Friend Sub AddRectBox(RectBox As Box_Data, ByVal TagData As Long)
Dim XY() As SingleXY
'lpIuWFNgǉ

    If ObjectType <> SpatialPointType.SPIRect Then
        MsgBox "lpȊO͂ł܂B", vbExclamation
        Exit Sub
    End If
    ReDim XY(1)
    XY(0).X = RectBox.left
    XY(0).Y = RectBox.top
    XY(1).X = RectBox.right
    XY(1).Y = RectBox.bottom
    Call Add_Point_Sub(2, XY(), TagData)
    
End Sub
