Attribute VB_Name = "modWheelMouse"
' @(s)
'
' TvF    zC[WW[BzC[NXƃZbgŎgp
'

Option Explicit

Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" _
    (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Public Const GWL_WNDPROC = (-4)
Public Const GWL_USERDATA = (-21)

Private Const WM_LBUTTONDOWN = &H201
Private Const WM_LBUTTONUP = &H202
Private Const WM_MBUTTONDOWN = &H207
Private Const WM_MBUTTONUP = &H208
Private Const WM_RBUTTONDOWN = &H204
Private Const WM_RBUTTONUP = &H205
Private Const WM_MOUSEWHEEL = &H20A

Private m_ColCWhell As Collection

Public Function WheelClassInitialise(ByRef inoWheel As clsWheelMouse, ByVal inlOwnerhWnd As Long) As Boolean
    Dim i As Long
    
    
    WheelClassInitialise = False
    
    If m_ColCWhell Is Nothing Then
        Set m_ColCWhell = New Collection
    End If
    
    '' K[hFnh0̏ꍇ͏I
    If inlOwnerhWnd = 0 Then Exit Function
    '' K[hFɓnho^Ăꍇɂ́AI
    For i = 1 To m_ColCWhell.Count
        If m_ColCWhell(i).OwnerhWnd = inlOwnerhWnd Then
            Exit Function
        End If
    Next i
    
    m_ColCWhell.Add inoWheel
    
    SetWindowLong inlOwnerhWnd, GWL_USERDATA, SetWindowLong(inlOwnerhWnd, GWL_WNDPROC, AddressOf SubClassProc)
    
    WheelClassInitialise = True

End Function

Public Sub WheelClassTerminate(ByVal inlOwnerhWnd As Long)
    Dim i As Long
    
    
    If m_ColCWhell Is Nothing Then Exit Sub
    
    For i = 1 To m_ColCWhell.Count
        If m_ColCWhell(i).OwnerhWnd = inlOwnerhWnd Then
            m_ColCWhell.Remove i
            Exit For
        End If
    Next i

End Sub

Private Function SubClassProc(ByVal hwndx As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim i As Long
    Dim Index As Long
    Dim zDelta As Integer
    Dim sngX As Single
    Dim sngY As Single
    Dim intHiWord As Integer
    Dim intLowWord As Integer
    
    
    If m_ColCWhell Is Nothing Then Exit Function
    If m_ColCWhell.Count = 0 Then Exit Function
    
    Static Calling As Boolean
    If Not Calling Then
        Index = 0
        For i = 1 To m_ColCWhell.Count
            If m_ColCWhell(i).OwnerhWnd = hwndx Then
                Index = i
                Exit For
            End If
        Next i
        If Index <> 0 Then
            Calling = True
            Select Case uMsg
            Case WM_MBUTTONDOWN, WM_MBUTTONUP   '' {^DownUp
                '' _u[h𕪊
                Call DWordToWord(lParam, intHiWord, intLowWord)
                '' ʃ[hYWFsNZTwipsɕϊ
                sngY = CSng(intHiWord) * Screen.TwipsPerPixelY
                '' ʃ[hXW
                sngX = CSng(intLowWord) * Screen.TwipsPerPixelX
                If (uMsg = WM_MBUTTONDOWN) Then
                    m_ColCWhell(i).raiseMyEvent 1, 0, sngX, sngY
                Else
                    m_ColCWhell(i).raiseMyEvent 2, 0, sngX, sngY
                End If
            
            Case WM_MOUSEWHEEL  '' Wheel񂵂
                zDelta = CInt(wParam / 2 ^ 16)
                If zDelta < 0 Then
                    '' zC[ɉ]ꍇ
                    m_ColCWhell(i).raiseMyEvent 3, -1, 0, 0
                Else
                    '' zC[Oɉ]ꍇ
                    m_ColCWhell(i).raiseMyEvent 3, 1, 0, 0
                End If
            End Select
        End If
        Calling = False
    End If
    SubClassProc = CallWindowProc(GetWindowLong(hwndx, GWL_USERDATA), hwndx, uMsg, wParam, lParam)
End Function

' @(f)
'
' @\F_u[hʃ[hƉʃ[hɕ
'
Private Sub DWordToWord(ByVal inlDoubleWord As Long, ByRef iniHiWord As Integer, ByRef iniLowWord As Integer)
 
    If (inlDoubleWord And &HFFFF&) > &H7FFF Then
        iniLowWord = (inlDoubleWord And &HFFFF&) - &H10000
    Else
        iniLowWord = inlDoubleWord And &HFFFF&
    End If
 
    iniHiWord = (inlDoubleWord And &HFFFF0000) \ &H10000
 
End Sub

