Attribute VB_Name = "Draw_Tile"
Option Explicit
Public Function Tile_Set(T As Tile_Property) As Boolean
    Push.Tile = T
    frmHatchSelecter.Show 1
    Tile_Set = False
    If Cancel_Button = False Then
        T = Push.Tile
        Tile_Set = True
    End If
    

End Function

Sub Draw_Sample_TileBox(ob As Object, T As Tile_Property)
Dim w As Single, H As Single
Dim oHDC As Long, Interval As Long
Dim w2 As Long, h2 As Long

    With ob
    w = .ScaleWidth
    H = .ScaleHeight
    .Cls
    Select Case T.TileCode
        Case 0, 1, 2, 3, 4, 5, 6, 9
            If T.BGColFlag = True Then
                ob.Line (0, 0)-(w, H), T.BGCOLOR, BF
            End If
            oHDC = .hdc
            Interval = Get_Length_On_Sample_Screen(T.Density)
            DrawTile 0, 0, w, H, T, Interval, oHDC, 1
        Case 7
            .fontsize = 9
            .fontname = General_Option.SetFont
            w2 = .TextWidth("")
            h2 = .TextHeight("")
            .CurrentX = w / 2 - w2 / 2
            .CurrentY = H / 2 - h2 / 2
            ob.Print ""
        Case 8
            ob.Line (0, 0)-(w, H), T.Line.BasicLine.SolidLine.Color, BF
    End Select
    End With
End Sub



Sub Draw_Tile_and_Paint_and_Line(pxy() As POINTAPI, nPolyP() As Long, ByVal polyn As Long, T As Tile_Property, L As Line_Property, ByVal O_HDC As Long, ByVal Size_mode As Integer)


    Call Draw_Poly_Inner(pxy(), nPolyP(), polyn, T, O_HDC, Size_mode)
    Call Draw_Poly_Line(pxy(), nPolyP(), polyn, L, O_HDC, Size_mode)

    
End Sub
Public Sub Draw_Poly_Line(pxy() As POINTAPI, nPolyP() As Long, polyn As Long, L As Line_Property, O_HDC As Long, ByVal Size_mode As Integer)
'polygon̗֊s
Dim i As Long, j As Long, s As Long
Dim pxy2() As POINTAPI, n As Long

    If polyn = 1 Then
        Draw_PolyLine pxy(), nPolyP(0), L, O_HDC, Size_mode
    Else
        For i = 0 To polyn - 1
            If i = 0 Then
                s = 0
            Else
                s = s + nPolyP(i - 1)
            End If
            n = nPolyP(i)
            ReDim pxy2(n - 1)
            For j = 0 To n - 1
                pxy2(j) = pxy(s + j)
            Next
            Draw_PolyLine pxy2(), n, L, O_HDC, Size_mode
        Next
    End If
End Sub
Public Sub Draw_Poly_Inner(pxy() As POINTAPI, nPolyP() As Long, ByVal polyn As Long, T As Tile_Property, O_HDC As Long, ByVal Size_mode As Integer)
'polygon̓hԂ
Dim i As Long, j As Long, n As Long


Dim minx As Single, miny As Single
Dim maxx As Single, maxy As Single

    n = 0
    minx = pxy(0).X: maxx = minx
    miny = pxy(0).Y: maxy = miny
    For i = 0 To polyn - 1
        For j = 0 To nPolyP(i) - 1
            With pxy(n)
                minx = mn(minx, .X)
                maxx = mx(maxx, .X)
                miny = mn(miny, .Y)
                maxy = mx(maxy, .Y)
            End With
            n = n + 1
        Next
    Next
    With T
        Select Case .TileCode
            Case 0, 1, 2, 3, 4, 5, 6, 9
                Call Draw_Tile_Region(minx, miny, maxx, maxy, pxy(), nPolyP(), polyn, T, O_HDC, Size_mode)
            Case 7
            Case 8
                With .Line.BasicLine
                    Call DrawPolyPolygon(pxy(), polyn, nPolyP(), .SolidLine.Color, O_HDC)
                End With
        End Select
    End With

End Sub
Public Sub Draw_Tile_Region(ByVal minx As Single, ByVal miny As Single, ByVal maxx As Single, ByVal maxy As Single, _
            pxy() As POINTAPI, nPolyP() As Long, ByVal polyn As Long, T As Tile_Property, O_HDC As Long, ByVal Size_mode As Integer)
'Size_Mode
'0:%
'1:Sample%
'2:̂܂(sNZ)
Dim i As Long, Sub_Clipping As Long, pxy2() As POINTAPI, Sub_F As Long
Dim PRGN As Long
Dim Interval As Long

    Call Set_Clipping_Region(polyn, pxy(), nPolyP(), Sub_Clipping, PRGN, Sub_F, O_HDC)
    
    With T
        If .BGColFlag = True Then
            Call DrawPolyPolygon(pxy(), polyn, nPolyP(), .BGCOLOR, O_HDC)
        End If
        Interval = Get_Length_by_Size_Mode(.Density, Size_mode)
    End With
    DrawTile minx, miny, maxx, maxy, T, Interval, O_HDC, Size_mode
    
    '쐬NbsO[W폜
    Call Clear_Clipping_Region(Sub_Clipping, PRGN, Sub_F, O_HDC)

End Sub

Sub Draw_Tile_Box(ByVal X1, ByVal Y1, ByVal x2, ByVal y2, ByVal Kakudo As Long, L As Line_Property, T As Tile_Property, ByVal O_HDC As Long, ByVal Size_mode As Integer)
Dim i As Long
Dim pxy() As POINTAPI, pxy2() As POINTAPI
Dim Sub_Clipping As Long, Sub_Clip_F As Long
Dim ClippingRGN As Long
Dim minx As Single, miny As Single
Dim maxx As Single, maxy As Single
Dim nPolyP(0) As Long, cn As Long
Dim xw As Long, yw As Long

    ReDim pxy(4)
    cn = 4
    If Kakudo <> 0 Then
        xw = (x2 - X1) / 2
        yw = (y2 - Y1) / 2
        pxy(0).X = -xw
        pxy(0).Y = -yw
        pxy(1).X = xw
        pxy(1).Y = -yw
        pxy(2).X = xw
        pxy(2).Y = yw
        pxy(3).X = -xw
        pxy(3).Y = yw
        For i = 0 To 3
            With pxy(i)
            Trans2D .X, .Y, -Kakudo
            .X = .X + X1 + xw
            .Y = .Y + Y1 + yw
            End With
        Next
    Else
        pxy(0).X = X1
        pxy(0).Y = Y1
        pxy(1).X = x2
        pxy(1).Y = Y1
        pxy(2).X = x2
        pxy(2).Y = y2
        pxy(3).X = X1
        pxy(3).Y = y2
    End If
    pxy(4) = pxy(0)
    
    minx = pxy(0).X: maxx = minx
    miny = pxy(0).Y: maxy = miny
    For i = 0 To 3
        With pxy(i)
            minx = mn(minx, .X)
            maxx = mx(maxx, .X)
            miny = mn(miny, .Y)
            maxy = mx(maxy, .Y)
        End With
    Next
    
    Select Case T.TileCode
        Case 0, 1, 2, 3, 4, 5, 6, 9
            nPolyP(0) = cn
            Call Draw_Tile_Region(minx, miny, maxx, maxy, pxy(), nPolyP(), 1, T, O_HDC, Size_mode)
        Case 7
        Case 8
            With T.Line.BasicLine
            DrawPolygon2 pxy(), cn, .SolidLine.Color, .SolidLine.Color, 1, 5, O_HDC
            End With
    End Select
    
    Draw_PolyLine pxy(), cn + 1, L, O_HDC, Size_mode
End Sub
Function Get_Meta_Region(pxy() As POINTAPI, ByVal n As Long) As POINTAPI()
Dim i As Long
Dim pxy2() As POINTAPI
'^t@Co͂̏ꍇ́ANbsO[W̓r[|[g̍WɂȂ
    ReDim pxy2(n - 1)
    For i = 0 To n - 1
        pxy2(i).X = pxy(i).X / TotalData.ScrData.PrinterMG.Mul
        pxy2(i).Y = pxy(i).Y / TotalData.ScrData.PrinterMG.Mul
    Next
    Get_Meta_Region = pxy2
End Function
Sub DrawTile(ByVal minx As Single, miny As Single, maxx As Single, maxy As Single, TI As Tile_Property, ByVal Interval, ByVal O_HDC As Long, ByVal Size_mode As Integer)
'Size_Mode
'0:%
'1:Sample%
'2:̂܂(sNZ)

Dim w  As Single, H As Single


    w = maxx - minx
    H = maxy - miny
    miny = miny - H * 0.05
    maxy = maxy + H * 0.05
    minx = minx - w * 0.05
    maxx = maxx + w * 0.05

    Select Case TI.TileCode
        Case 0
            Call DrawTile_Point_Tile(minx, miny, maxx, maxy, Interval, TI.Line, O_HDC, Size_mode)
        Case 1
            Call DrawTile_Line_Tile(minx, miny, maxx, maxy, 0, Interval, TI.Line, O_HDC, Size_mode)
        Case 2
            Call DrawTile_Line_Tile(minx, miny, maxx, maxy, 1, Interval, TI.Line, O_HDC, Size_mode)
        Case 3
            Call DrawTile_Line_Tile(minx, miny, maxx, maxy, 2, Interval, TI.Line, O_HDC, Size_mode)
        Case 4
            Call DrawTile_Line_Tile(minx, miny, maxx, maxy, 3, Interval, TI.Line, O_HDC, Size_mode)
        Case 5
            Call DrawTile_Line_Tile(minx, miny, maxx, maxy, 1, Interval, TI.Line, O_HDC, Size_mode)
            Call DrawTile_Line_Tile(minx, miny, maxx, maxy, 0, Interval, TI.Line, O_HDC, Size_mode)
        Case 6
            Call DrawTile_Line_Tile(minx, miny, maxx, maxy, 2, Interval, TI.Line, O_HDC, Size_mode)
            Call DrawTile_Line_Tile(minx, miny, maxx, maxy, 3, Interval, TI.Line, O_HDC, Size_mode)
        Case 7
        Case 8
            Call DrawRectangle(minx, miny, maxx, maxy, TI.Line.BasicLine.SolidLine.Color, TI.Line.BasicLine.SolidLine.Color, 0, 0, O_HDC)
        Case 9
            Call DrawTile_Mark_Tile(minx, miny, maxx, maxy, Interval, TI, O_HDC, Size_mode)
    End Select

End Sub
Private Sub DrawTile_Point_Tile(ByVal minx As Single, miny As Single, maxx As Single, maxy As Single, ByVal Interval, LPat As Line_Property, ByVal O_HDC As Long, ByVal Size_mode As Integer)
Dim ic As Long, ic2 As Long
Dim j As Long
Dim LineWidth As Single
Dim TCOL As Long
Dim Psize As Long
Dim Hint As Long
Dim stx As Single, sty As Single
Dim LINY As Single
Dim X As Long, Y As Long, psx As Single

    LineWidth = LPat.BasicLine.SolidLine.Width
    TCOL = LPat.BasicLine.SolidLine.Color
    
    Psize = Get_Length_by_Size_Mode(LineWidth, Size_mode)
    
    If Psize = 0 Then Psize = 1
    
    Hint = Int(miny / Interval)
    sty = Interval * Hint - Interval
    Hint = Abs(Hint - 1) Mod 2
    ic = 0
    Do
        LINY = sty + Interval * ic
        stx = Int(minx / Interval) * Interval - Interval * (Hint / 2 - 1)
        ic2 = 0
        Do
            psx = stx + ic2 * Interval
            X = psx
            Y = LINY
            If Psize = 1 Then
                DrawPset X, Y, TCOL, O_HDC
            Else
                DrawEllipse X, Y, Int(Psize / 2), TCOL, TCOL, 0, 0, O_HDC
            End If
            ic2 = ic2 + 1
        Loop While psx + Interval < maxx
        ic = ic + 1
        Hint = 1 - Hint
    Loop While LINY + Interval < maxy
End Sub
Private Sub DrawTile_Mark_Tile(ByVal minx As Single, miny As Single, maxx As Single, maxy As Single, ByVal Interval, TI As Tile_Property, ByVal O_HDC As Long, ByVal Size_mode As Integer)
Dim ic As Long, ic2 As Long
Dim j As Long
Dim LineWidth As Single
Dim Psize As Long
Dim Hint As Long
Dim stx As Single, sty As Single
Dim LINY As Single
Dim X As Long, Y As Long
Dim MK As Mark_Property, psx As Single

    LineWidth = TI.Line.BasicLine.SolidLine.Width
    Psize = Get_Length_by_Size_Mode(LineWidth, Size_mode)
    
    MK = Base.Mark
    With TI.Mark
    MK.Shape = .Shape
    MK.PrintMark = .PrintMark
    MK.PictureNumber = .PictureNumber
    MK.wordmark = .wordmark
    MK.WordFont = Base.Font
    MK.WordFont.Body.Name = .WordFontName
    MK.WordFont.Body.Kakudo = .Kakudo
    MK.Line.BasicLine.SolidLine.Color = .Mark_Line_Color
    End With
    MK.Tile.TileCode = 8
    With TI.Line.BasicLine.SolidLine
    MK.WordFont.Body.Color = .Color
    MK.Tile.Line.BasicLine.SolidLine.Color = .Color
    End With
    If Psize = 0 Then Psize = 1
    
    Hint = Int(miny / Interval)
    sty = Interval * Hint - Interval
    Hint = Abs(Hint - 1) Mod 2
    ic = 0
    Do
        LINY = sty + Interval * ic
        stx = Int(minx / Interval) * Interval - Interval * (Hint / 2 - 1)
        ic2 = 0
        Do
            psx = stx + ic2 * Interval
            X = psx
            Y = LINY
            Mark_Print X, Y, Int(Psize / 2), MK, O_HDC, Size_mode
            ic2 = ic2 + 1
        Loop While psx + Interval < maxx
        ic = ic + 1
        Hint = 1 - Hint
    Loop While LINY + Interval < maxy
End Sub
Private Sub DrawTile_Line_Tile(ByVal minx As Single, miny As Single, maxx As Single, maxy As Single, ByVal LineDIR As Integer, ByVal Interval, LPat As Line_Property, ByVal O_HDC As Long, ByVal Size_mode As Integer)
'LineDIR:0@1c@2Eォ獶@3ォE
Dim oldPen As Long, Pen As Long, H As Long, OSP As Long
Dim X As Long, Y As Long
Dim x2 As Long, y2 As Long
Dim ic As Long, j As Long
Dim LINX As Single, LINY As Single
Dim Interval2 As Single
Dim cx As Long, cx2 As Long
Dim Hint As Single, sty As Single, stx As Single, w As Single

    Select Case LineDIR
    Case 0
        Hint = Int(miny / Interval)
        sty = Interval * Hint - Interval
        ic = 0
        Do
            LINY = sty + Interval * ic
            Y = LINY
            y2 = Y
            X = minx
            x2 = maxx
            Draw_Line X, Y, x2, y2, LPat, O_HDC, Size_mode
            ic = ic + 1
        Loop While LINY + Interval < maxy
    Case 1
        Hint = Int(minx / Interval)
        stx = Interval * Hint - Interval
        ic = 0
        Do
            LINX = stx + Interval * ic
            X = LINX
            x2 = X
            Y = miny
            y2 = maxy
            Draw_Line X, Y, x2, y2, LPat, O_HDC, Size_mode
            ic = ic + 1
        Loop While LINX + Interval < maxx
    Case 2, 3
        Interval2 = Interval * Sqr(2)
        Select Case LineDIR
            Case 2
                maxx = Int(maxx / Interval2) * Interval2 + Interval2
                miny = Int(miny / Interval2) * Interval2
                X = maxx
                x2 = minx
            Case 3
                miny = Int(miny / Interval2) * Interval2
                minx = Int(minx / Interval2) * Interval2
                X = minx
                x2 = maxx
        End Select
        w = maxx - minx
        Hint = Int((miny - w) / Interval2)
        sty = Interval2 * Hint - Interval2
        ic = 0
        Do
            LINY = sty + Interval2 * ic
            Y = LINY
            y2 = LINY + w
            
            If miny <= y2 And Y <= maxy Then
                If Y < miny And y2 < maxy Then 'ɂ͂ݏoꍇ
                    cx = (X - x2) / (Y - y2) * (miny - Y) + X
                    Draw_Line cx, miny, x2, y2, LPat, O_HDC, Size_mode
                ElseIf Y <= miny And maxy < y2 Then  '㉺ɂ͂ݏoꍇ
                    cx = (X - x2) / (Y - y2) * (miny - Y) + X
                    cx2 = (X - x2) / (Y - y2) * (maxy - Y) + X
                    Draw_Line cx, miny, cx2, maxy, LPat, O_HDC, Size_mode
                ElseIf maxy < y2 Then  'ɂ͂ݏoꍇ
                    cx2 = (X - x2) / (Y - y2) * (maxy - Y) + X
                    Draw_Line X, Y, cx2, maxy, LPat, O_HDC, Size_mode
                Else  '͂ݏoȂꍇ
                    Draw_Line X, Y, x2, y2, LPat, O_HDC, Size_mode
                End If
            End If
            ic = ic + 1
        Loop While LINY + Interval2 < maxy

    End Select


End Sub





