Attribute VB_Name = "JPGIS"
Option Explicit
Public Type JPGIS_StacNum_Info
    Object As Long
    Surface As Long
    Curve As Long
    Point As Long
    CurveID As Long
    NodeID As Long
End Type

Public Type JPGIS_ObjectData_Info
    ID As String
    Attr(10) As String
    XTAG As String
    RefStac As Long
    Converted_F As Boolean
End Type




'Public Type JPGIS_CurveID_Stac_Info 'PȂlong
'    CurveNum As Long
'End Type

Public Type JPGIS_SurfaceData_Info
    CurveStac As Long
    CurveNum As Long
End Type



Public Type JPGIS_Curve_Info
    StartNodeStac As Long
    EndNodeStac As Long
    Stac As Long
    Pointnum As Long
    MpLineNumber As Long
End Type

'Public Type JPGIS_Point_XY 'PȂsingleXY
'    X As Double
'    Y As Double
'End Type
'
'Public Type JPGIS_NodeID_Stac_Info@'PȂsingleXY
'    ID As String
'    X As Double
'    Y As Double
'End Type


Public Type JPGIS_Object_TAG_Info
    Shape As Long
    XTAG As String
    IDRefTAG As String
    IDRefTAGSub As String
    SubTagNum As Long
    SubTAG(10) As String
End Type
'------
Private Type JPGIS_ObjectData_Info_Private
    Attr(11) As String
    XTAG As String
    ID As String
    IDref As String
    IDRefSub As String
    Shape As Long
End Type

Private Type JPGIS_StacNum_Info_Private
    Object As Long
    Surface As Long
    Curve As Long
    Point As Long
    CurveID As Long
    NodeID As Long
    OrientCurve As Long
    Record As Long
End Type


Private Type JPGIS_CurveID_Stac_Info_Private
    IDref As String
End Type

Private Type JPGIS_SurfaceData_Info_Private
    ID As String
    CurveStac As Long
    CurveNum As Long
End Type



Private Type JPGIS_Curve_Info_Private
    ID As String
    StartNodeIDRef As String
    EndNodeIDRef As String
    Stac As Long
    Pointnum As Long
    MpLineNumber As Long
End Type

Private Type JPGIS_Point_XY_Private
    X As Double
    Y As Double
End Type

Private Type JPGIS_NodeID_Stac_Info_Private
    ID As String
    X As Double
    Y As Double
End Type




Private Type JPGIS_Orient_Curve_info
    ID As String
    IDref As String
End Type
Private Type JPGIS_Record_Info
    ID As String
    Attr(10) As String
End Type

Private Sub Get_JPGIS_XML_Record(ByVal FileNum As Long, ByVal ST$, ByVal XTAG As String, ByVal idHeader As String, _
            ByRef Record_Stac() As JPGIS_Record_Info, ByRef StacNum As JPGIS_StacNum_Info_Private)
Dim ln As Long, n As Long, a$
'݂̂Ƃ됔ln}25000(yn)ln}5000iynpĵ݁Bɂ悤Ȃ܂Č
    
    ln = StacNum.Record
    If UBound(Record_Stac) < ln Then
        ReDim Preserve Record_Stac(ln + 100)
    End If
    n = 0
    With Record_Stac(ln)
        .ID = idHeader & Get_JPGIS_XML_Strings(ST$, Chr$(34), Chr$(34))
        Do
            Line Input #FileNum, a$
            If InStr(a$, "<jps:Record.attributes>") <> 0 Then
                .Attr(n) = ""
                Do
                    Line Input #FileNum, a$
                    If InStr(a$, "AttributeName") <> 0 Then
                        .Attr(n) = .Attr(n) & "AttributeName" & TB & Get_JPGIS_XML_Strings(a$, ">", "<") & TB
                    ElseIf InStr(a$, "Any") <> 0 Then
                        .Attr(n) = .Attr(n) & "Any" & TB & Get_JPGIS_XML_Strings(a$, ">", "<") & TB
                    End If
                Loop Until InStr(a$, "</jps:Record.attributes>") <> 0
                n = n + 1
            End If
        Loop Until InStr(a$, "</jps:Record>") <> 0
    End With
    StacNum.Record = StacNum.Record + 1
End Sub


Private Sub Get_JPGIS_XML_OrientCurve(ByVal FileNum As Long, ByVal ST$, ByVal XTAG As String, ByVal idHeader As String, _
            ByRef Orient_Curve_Stac() As JPGIS_Orient_Curve_info, ByRef StacNum As JPGIS_StacNum_Info_Private)
Dim ln As Long, a$

    ln = StacNum.OrientCurve
    If UBound(Orient_Curve_Stac) < ln Then
        ReDim Preserve Orient_Curve_Stac(ln + 100)
    End If
    With Orient_Curve_Stac(ln)
        .ID = idHeader & Get_JPGIS_XML_Strings(ST$, Chr$(34), Chr$(34))
        Do
            Line Input #FileNum, a$
            If InStr(a$, "GM_OrientablePrimitive.primitive") <> 0 Then
                .IDref = idHeader & Get_JPGIS_XML_Strings(a$, Chr$(34), Chr$(34))
            End If
        Loop Until InStr(a$, "</" & XTAG & ">") <> 0
    End With
    StacNum.OrientCurve = StacNum.OrientCurve + 1
End Sub

Private Sub Get_JPGIS_XML_Node(ByVal FileNum As Long, ByVal ST$, ByVal XTAG As String, ByVal idHeader As String, _
            ByRef NodeID_Stac() As JPGIS_NodeID_Stac_Info_Private, ByRef StacNum As JPGIS_StacNum_Info_Private)
Dim ln As Long, a$

    ln = StacNum.NodeID
    If UBound(NodeID_Stac) < ln Then
        ReDim Preserve NodeID_Stac(ln + 100)
    End If
    
    With NodeID_Stac(ln)
        .ID = idHeader & Get_JPGIS_XML_Strings(ST$, Chr$(34), Chr$(34))
        Do
            Line Input #FileNum, a$
            If InStr(a$, "DirectPosition.coordinate") <> 0 Then
                Call Split_SpaceXY(a$, .Y, .X)
            End If
        Loop Until InStr(a$, "</" & XTAG & ">") <> 0
   End With
    StacNum.NodeID = StacNum.NodeID + 1

End Sub

Private Sub Get_JPGIS_XML_Curve(ByVal FileNum As Long, ByVal ST$, ByVal XTAG As String, ByVal idHeader As String, _
            ByRef Curve_Stac() As JPGIS_Curve_Info_Private, ByRef Point_Stac() As JPGIS_Point_XY_Private, ByRef StacNum As JPGIS_StacNum_Info_Private)
'sE̐
Dim ln As Long, prf As Integer, a$

    ln = StacNum.Curve
    If UBound(Curve_Stac) < ln Then
        ReDim Preserve Curve_Stac(ln + 100)
    End If

    With Curve_Stac(ln)
        .ID = idHeader & Get_JPGIS_XML_Strings(ST$, Chr$(34), Chr$(34))
        .Stac = StacNum.Point
        .MpLineNumber = -1
    End With
    
    prf = 0
    Do
        Line Input #FileNum, a$
        If InStr(a$, "GM_PointRef.point") <> 0 Then
            If prf = 0 Then
                Curve_Stac(ln).StartNodeIDRef = idHeader & Get_JPGIS_XML_Strings(a$, Chr$(34), Chr$(34))
                prf = 1
            Else
                Curve_Stac(ln).EndNodeIDRef = idHeader & Get_JPGIS_XML_Strings(a$, Chr$(34), Chr$(34))
            End If
        ElseIf InStr(a$, "DirectPosition.coordinate") <> 0 Then
            Call Get_Point(a$, Point_Stac(), StacNum)
        End If
    Loop Until InStr(a$, "</" & XTAG & ">") <> 0
    Curve_Stac(ln).Pointnum = StacNum.Point - Curve_Stac(ln).Stac
    StacNum.Curve = ln + 1
    

End Sub
Private Sub Get_JPGIS_XML_Surface(ByVal FileNum As Long, ByVal ST$, ByVal XTAG As String, ByVal idHeader As String, _
            ByRef Surface_Stac() As JPGIS_SurfaceData_Info_Private, ByRef CurveID_Stac() As JPGIS_CurveID_Stac_Info_Private, ByRef StacNum As JPGIS_StacNum_Info_Private)
Dim i As Long, ln As Long, prf As Integer, a$

    ln = StacNum.Surface
    If UBound(Surface_Stac) < ln Then
        ReDim Preserve Surface_Stac(ln + 100)
    End If
    With Surface_Stac(ln)
        .ID = idHeader & Get_JPGIS_XML_Strings(ST$, Chr$(34), Chr$(34))
        .CurveStac = StacNum.CurveID
    End With
    
    Do
        Line Input #FileNum, a$
        If InStr(a$, "GM_CompositeCurve.generator") <> 0 Then
            If UBound(CurveID_Stac) < StacNum.CurveID Then
                ReDim Preserve CurveID_Stac(StacNum.CurveID + 100)
            End If
            CurveID_Stac(StacNum.CurveID).IDref = idHeader & Get_JPGIS_XML_Strings(a$, Chr$(34), Chr$(34))
            StacNum.CurveID = StacNum.CurveID + 1
        End If
    Loop Until InStr(a$, "</" & XTAG & ">") <> 0
    Surface_Stac(ln).CurveNum = StacNum.CurveID - Surface_Stac(ln).CurveStac
    StacNum.Surface = ln + 1
    

End Sub

Private Sub Get_Point(a$, Point_Stac() As JPGIS_Point_XY_Private, ByRef StacNum As JPGIS_StacNum_Info_Private)
Dim n As Long

    n = StacNum.Point
    If UBound(Point_Stac) < n Then
        ReDim Preserve Point_Stac(n + 100)
    End If
    With Point_Stac(n)
    Call Split_SpaceXY(a$, .Y, .X)
    End With
    StacNum.Point = n + 1
End Sub

Public Sub Split_SpaceXY(a$, ByRef X As Double, ByRef Y As Double)
'
Dim SP As Long, s$

    s$ = Get_JPGIS_XML_Strings(a$, ">", "<")
    SP = InStr(s$, " ")
    X = Val(Mid$(s$, 1, SP - 1))
    Y = Val(Mid$(s$, SP + 1))

End Sub

Private Function Get_JPGIS_XML_Strings(a$, fs$, ES$) As String
'w肵ň͂܂ꂽo
Dim i1 As Long, i2 As Long

    i1 = InStr(a$, fs$)
    i2 = InStrRev(a$, ES$)
    If i1 = 0 Or i2 = 0 Or i2 < i1 Then
        Get_JPGIS_XML_Strings = ""
    Else
        Get_JPGIS_XML_Strings = Mid$(a$, i1 + 1, i2 - i1 - 1)
'        If left$(Get_Strings, 1) = "_" Then
'            Get_Strings = Mid$(Get_Strings, 2)
'        End If
    End If
End Function

Private Sub Set_Record_to_Object_Attr(Record_Stac() As JPGIS_Record_Info, Object_Stac() As JPGIS_ObjectData_Info_Private, StacNum As JPGIS_StacNum_Info_Private)
'jps:Record̑IuWFNg̑Ɋ蓖Ă
'݂̂Ƃ됔ln}25000(yn)5000iynpĵ݁Bɂ悤Ȃ܂Č
Dim i As Long, j As Long, k As Long, n As Long
Dim eq_num As Long
Dim ATD() As String
Dim Record_IDSorted As SortingSearch

    If StacNum.Record = 0 Then
        Exit Sub
    End If

    Set Record_IDSorted = New SortingSearch
    With Record_IDSorted
        .AddInit vbString
        For i = 0 To StacNum.Record - 1
            .AddString Record_Stac(i).ID
        Next
        .AddEnd
    End With

    For i = 0 To StacNum.Object - 1
        With Object_Stac(i)
        n = Record_IDSorted.SearchData_One(.IDRefSub)
        If n <> -1 Then
            For j = 0 To 10
                .Attr(j) = ""
                ATD = Split(Record_Stac(n).Attr(j), TB)
                For k = 0 To UBound(ATD) - 1 Step 2
                    .Attr(j) = .Attr(j) & ATD(k + 1) & TB
                Next
            Next
        End If
        End With
    Next
    Set Record_IDSorted = Nothing
End Sub
Private Sub Replace_OrientativeID(Orient_Curve_Stac() As JPGIS_Orient_Curve_info, CurveID_Stac() As JPGIS_CurveID_Stac_Info_Private, ByRef StacNum As JPGIS_StacNum_Info_Private)
Dim i As Long, n As Long
Dim Orient_Curve_IDSorted As SortingSearch

    If StacNum.OrientCurve = 0 Then
        Exit Sub
    End If
    
    Set Orient_Curve_IDSorted = New SortingSearch
    With Orient_Curve_IDSorted
        .AddInit vbString
        For i = 0 To StacNum.OrientCurve - 1
            .AddString Orient_Curve_Stac(i).ID
        Next
        .AddEnd
    End With
            
    'J[u̕ĂX^bNAJ[u̎QƐƂo
    For i = 0 To StacNum.CurveID - 1
        With CurveID_Stac(i)
            n = Orient_Curve_IDSorted.SearchData_One(.IDref)
            If n <> -1 Then
                .IDref = Orient_Curve_Stac(n).IDref
            End If
        End With
    Next
    Set Orient_Curve_IDSorted = Nothing
End Sub
Private Sub Get_JPGIS_XML_Object(ByVal FileNum As Long, ByVal ST$, ByVal idHeader As String, _
                ByRef ObjectTag As JPGIS_Object_TAG_Info, ByRef Object_Stac() As JPGIS_ObjectData_Info_Private, ByRef StacNum As JPGIS_StacNum_Info_Private)
'IuWFNg擾
Dim i As Long, ln As Long, a$
Dim End_XTG As String


    ln = StacNum.Object
    If UBound(Object_Stac) < ln Then
        ReDim Preserve Object_Stac(ln + 100)
    End If
    
    If left$(ObjectTag.XTAG, 1) = "<" Then
        End_XTG = Mid$(ObjectTag.XTAG, 2)
    Else
        End_XTG = ObjectTag.XTAG
    End If
    End_XTG = RTrim(End_XTG)
    
    With Object_Stac(ln)
    .XTAG = End_XTG
    .Shape = ObjectTag.Shape
    .ID = idHeader & Get_JPGIS_XML_Strings(ST$, Chr$(34), Chr$(34))
    Do
        Line Input #FileNum, a$
        If InStr(a$, ObjectTag.IDRefTAG) <> 0 Then
            .IDref = idHeader & Get_JPGIS_XML_Strings(a$, Chr$(34), Chr$(34))
        ElseIf InStr(a$, ObjectTag.IDRefTAGSub) <> 0 And ObjectTag.IDRefTAGSub <> "" Then
            .IDRefSub = idHeader & Get_JPGIS_XML_Strings(a$, Chr$(34), Chr$(34))
        Else
            For i = 0 To ObjectTag.SubTagNum - 1
                If InStr(a$, ObjectTag.SubTAG(i)) <> 0 Then
                    .Attr(i) = Get_JPGIS_XML_Strings(a$, ">", "<")
                    Exit For
                End If
            Next
        End If
    Loop Until InStr(a$, "</" & End_XTG & ">") <> 0
    End With
    StacNum.Object = ln + 1
End Sub

Public Sub Read_XML_File(ByVal fi$, ByVal idHeader As String, ObjectTag() As JPGIS_Object_TAG_Info, ByVal ObjectTag_Num As Long, _
    P_Surface_Stac() As JPGIS_SurfaceData_Info, P_NodeID_Stac() As SingleXY, P_Curve_Stac() As JPGIS_Curve_Info, _
    P_Point_Stac() As SingleXY, P_Object_Stac() As JPGIS_ObjectData_Info, P_CurveID_Stac() As Long, P_StacNum As JPGIS_StacNum_Info, _
     lblCap As String, ProgressLabel As ProgressLabel)
'JPGISΉXMLt@Cǂݍłꂼ̃X^bNɕނ


Dim StacNum As JPGIS_StacNum_Info_Private
Dim CurveID_Stac() As JPGIS_CurveID_Stac_Info_Private
Dim Surface_Stac() As JPGIS_SurfaceData_Info_Private
Dim Surface_IDSorted As SortingSearch

Dim Curve_Stac() As JPGIS_Curve_Info_Private
Dim Curve_IDSorted As SortingSearch

Dim Point_Stac() As JPGIS_Point_XY_Private
Dim NodeID_Stac() As JPGIS_NodeID_Stac_Info_Private
Dim Node_IDSorted As SortingSearch

Dim Object_Stac() As JPGIS_ObjectData_Info_Private

Dim i As Long, j As Long, k As Long, cln As Long
Dim S_L() As Long, a$
Dim LCode2(), PStac2() As Long, LPNum2() As Long
Dim OpenFileMode As Boolean
Dim XTG(5) As String
Dim TempFile_F As Boolean, OPF As String
Dim Attr() As String
Dim Orient_Curve_Stac() As JPGIS_Orient_Curve_info
Dim Record_Stac() As JPGIS_Record_Info
Dim jps_f As Boolean, FileNum As Long, n As Long
Dim O_StacNum As JPGIS_StacNum_Info

    With StacNum
        .Curve = 0
        .CurveID = 0
        .Object = 0
        .Surface = 0
        .Point = 0
        .NodeID = 0
        .OrientCurve = 0
        .Record = 0
    End With
    ReDim Orient_Curve_Stac(0)
    ReDim Record_Stac(0)
    ReDim Point_Stac(0)
    ReDim Curve_Stac(0)
    ReDim Surface_Stac(0)
    ReDim Object_Stac(0)
    ReDim CurveID_Stac(0)
    ReDim NodeID_Stac(0)
    
    XTG(0) = "jps:GM_Point"
    XTG(1) = "jps:GM_Curve"
    XTG(2) = "jps:GM_Surface"
    XTG(3) = "jps:GM_OrientableCurve"
    XTG(4) = "jps:Record "
    O_StacNum = P_StacNum


    OPF = Check_File_Code(fi$, ProgressLabel, TempFile_F)



    FileNum = FreeFile()
    Open OPF For Input As #FileNum
    ProgressLabel.Visible = True
    ProgressLabel.Start LOF(FileNum), lblCap & "t@Cǂݍݒ"
            

    n = 0
    Do Until EOF(FileNum) = True
        If n = 100 Then
            ProgressLabel.SetValue Loc(FileNum) * 128
            DoEvents
            n = 0
        End If
        Line Input #FileNum, a$

        jps_f = False
        For i = 0 To 4
            If InStr(a$, XTG(i)) <> 0 Then
                Select Case i
                    Case 0
                        Call Get_JPGIS_XML_Node(FileNum, a$, XTG(i), idHeader, NodeID_Stac(), StacNum)
                    Case 1
                        Call Get_JPGIS_XML_Curve(FileNum, a$, XTG(i), idHeader, Curve_Stac(), Point_Stac(), StacNum)
                    Case 2
                        Call Get_JPGIS_XML_Surface(FileNum, a$, XTG(i), idHeader, Surface_Stac(), CurveID_Stac(), StacNum)
                    Case 3
                        Call Get_JPGIS_XML_OrientCurve(FileNum, a$, XTG(i), idHeader, Orient_Curve_Stac(), StacNum)
                    Case 4
                        Call Get_JPGIS_XML_Record(FileNum, a$, XTG(i), idHeader, Record_Stac(), StacNum)
                End Select
                jps_f = True
                Exit For
            End If
        Next
        If jps_f = False Then
            For i = 0 To ObjectTag_Num - 1
                If InStr(a$, ObjectTag(i).XTAG) <> 0 Then
                    Call Get_JPGIS_XML_Object(FileNum, a$, idHeader, ObjectTag(i), Object_Stac(), StacNum)
                    Exit For
                End If
            Next
        End If
        n = n + 1
    Loop
     ProgressLabel.SetValue LOF(FileNum)
     DoEvents
    Close FileNum
        
    If TempFile_F = True Then
        Call Kill_TempFile(OPF)
    End If
    
    'IDp
    If StacNum.Surface > 0 Then
        Set Surface_IDSorted = New SortingSearch
        With Surface_IDSorted
            .AddInit vbString
            For i = 0 To StacNum.Surface - 1
                .AddString Surface_Stac(i).ID
            Next
            .AddEnd
        End With
    End If
    
    If StacNum.NodeID > 0 Then
        Set Node_IDSorted = New SortingSearch
        With Node_IDSorted
            .AddInit vbString
            For i = 0 To StacNum.NodeID - 1
                .AddString NodeID_Stac(i).ID
            Next
            .AddEnd
        End With
    End If
    
    If StacNum.Curve > 0 Then
        Set Curve_IDSorted = New SortingSearch
        With Curve_IDSorted
            .AddInit vbString
            For i = 0 To StacNum.Curve - 1
                .AddString Curve_Stac(i).ID
            Next
            .AddEnd
        End With
    End If

    
    Call Replace_OrientativeID(Orient_Curve_Stac(), CurveID_Stac(), StacNum)
    Call Set_Record_to_Object_Attr(Record_Stac(), Object_Stac(), StacNum)
    
    With P_StacNum
        .Object = .Object + StacNum.Object
        .Surface = .Surface + StacNum.Surface
        .Curve = .Curve + StacNum.Curve
        .CurveID = .CurveID + StacNum.CurveID
        .NodeID = .NodeID + StacNum.NodeID
        .Point = .Point + StacNum.Point
        ReDim Preserve P_Object_Stac(.Object - 1)
        ReDim Preserve P_Surface_Stac(.Surface)
        ReDim Preserve P_NodeID_Stac(.NodeID)
        ReDim Preserve P_Curve_Stac(.Curve)
        ReDim Preserve P_Point_Stac(.Point)
        ReDim Preserve P_CurveID_Stac(.CurveID)
    End With
    
    
    For i = 0 To StacNum.Object - 1
        With P_Object_Stac(O_StacNum.Object + i)
            .ID = Object_Stac(i).ID
            For j = 0 To 10
                .Attr(j) = Object_Stac(i).Attr(j)
            Next
            .Converted_F = False
            .XTAG = Object_Stac(i).XTAG
            Select Case Object_Stac(i).Shape
                Case PointShape
                    .RefStac = Node_IDSorted.SearchData_One(Object_Stac(i).IDref) + O_StacNum.NodeID
                Case LineShape
                    .RefStac = Curve_IDSorted.SearchData_One(Object_Stac(i).IDref) + O_StacNum.Curve
                Case PolygonShape
                    .RefStac = Surface_IDSorted.SearchData_One(Object_Stac(i).IDref) + O_StacNum.Surface
            End Select
        End With
    Next
    
    For i = 0 To StacNum.Surface - 1
        With P_Surface_Stac(O_StacNum.Surface + i)
            .CurveNum = Surface_Stac(i).CurveNum
            .CurveStac = Surface_Stac(i).CurveStac + O_StacNum.CurveID
        End With
    Next
    
    For i = 0 To StacNum.Curve - 1
        With P_Curve_Stac(O_StacNum.Curve + i)
            .Pointnum = Curve_Stac(i).Pointnum
            .Stac = Curve_Stac(i).Stac + O_StacNum.Point
            .EndNodeStac = Node_IDSorted.SearchData_One(Curve_Stac(i).EndNodeIDRef) + O_StacNum.NodeID
            .StartNodeStac = Node_IDSorted.SearchData_One(Curve_Stac(i).StartNodeIDRef) + O_StacNum.NodeID
            .MpLineNumber = -1
        End With
    Next
    
    For i = 0 To StacNum.CurveID - 1
        P_CurveID_Stac(O_StacNum.CurveID + i) = Curve_IDSorted.SearchData_One(CurveID_Stac(i).IDref) + O_StacNum.Curve
    Next
    
    For i = 0 To StacNum.NodeID - 1
        With P_NodeID_Stac(O_StacNum.NodeID + i)
            .X = CSng(NodeID_Stac(i).X)
            .Y = CSng(NodeID_Stac(i).Y)
        End With
    Next
    
    For i = 0 To StacNum.Point - 1
        With P_Point_Stac(O_StacNum.Point + i)
            .X = CSng(Point_Stac(i).X)
            .Y = CSng(Point_Stac(i).Y)
        End With
    Next
    
    ProgressLabel.Visible = False
    Set Surface_IDSorted = Nothing
    Set Node_IDSorted = Nothing
    Set Curve_IDSorted = Nothing
End Sub
Public Function Set_One_Line(ByVal LCode As Long, ByVal LineKind As Long, XY_Rect As Box_Data, _
            Curve_Stac() As JPGIS_Curve_Info, Point_Stac() As SingleXY, NodeID_Stac() As SingleXY) As Boolean
'C͈͂mFēo^
Dim Pnum As Long, k As Long, oap As Long
Dim Snode As Long, Enode As Long, Oalin As Long


    Snode = Curve_Stac(LCode).StartNodeStac
    Enode = Curve_Stac(LCode).EndNodeStac
    If Check_PointInBox_SingleXY(NodeID_Stac(Snode), 0, XY_Rect) = True Or _
         Check_PointInBox_SingleXY(NodeID_Stac(Enode), 0, XY_Rect) = True Then
        Oalin = Map.ALIN
        Call CheckMPLine_Dim(Oalin + 1)
        With Curve_Stac(LCode)
            Pnum = .Pointnum + 2
            Call Init_One_Line(MPLine(Oalin))
            .MpLineNumber = Map.ALIN
            With MPLine(Map.ALIN)
                .NumOfPoint = Pnum
                .LineTimeSTC(0).Kind = LineKind
                ReDim .PointSTC(Pnum - 1)
                Call Get_Converted_XY(.PointSTC(0).X, .PointSTC(0).Y, NodeID_Stac(Snode).X, NodeID_Stac(Snode).Y, Map)
                For k = 0 To Pnum - 3
                    Call Get_Converted_XY(.PointSTC(k + 1).X, .PointSTC(k + 1).Y, Point_Stac(k + Curve_Stac(LCode).Stac).X, Point_Stac(k + Curve_Stac(LCode).Stac).Y, Map)
                Next
                Call Get_Converted_XY(.PointSTC(Pnum - 1).X, .PointSTC(Pnum - 1).Y, NodeID_Stac(Enode).X, NodeID_Stac(Enode).Y, Map)
            End With
        End With
        Map.ALIN = Map.ALIN + 1
        Set_One_Line = True
    End If
End Function
Public Sub init_XML_Stac(StacNum As JPGIS_StacNum_Info, CurveID_Stac() As Long, Surface_Stac() As JPGIS_SurfaceData_Info, _
            Curve_Stac() As JPGIS_Curve_Info, Point_Stac() As SingleXY, NodeID_Stac() As SingleXY, Object_Stac() As JPGIS_ObjectData_Info)

    With StacNum
        .Curve = 0
        .CurveID = 0
        .NodeID = 0
        .Object = 0
        .Point = 0
        .Surface = 0
    End With
    
    ReDim Point_Stac(0)
    ReDim Curve_Stac(0)
    ReDim Surface_Stac(0)
    ReDim Object_Stac(0)
    ReDim CurveID_Stac(0)
    ReDim NodeID_Stac(0)
End Sub
Public Function Get_JPGIS_MapBOX(ByVal Tokyo_Island_f As Boolean, NodeID_Stac() As SingleXY, Point_Stac() As SingleXY, StacNum As JPGIS_StacNum_Info) As Box_Data
'n}̑傫擾
Dim XY_Rect As Box_Data
Dim i As Long

    With XY_Rect
        .left = Point_Stac(0).X
        .bottom = Point_Stac(0).Y
        .right = .left
        .top = .bottom
    End With
    
    For i = 0 To StacNum.Point - 1
        If (Tokyo_Island_f = False And Point_Stac(i).Y >= 34.83) Or Tokyo_Island_f = True Then
            Call Get_Circumscribed_Rectangle(Point_Stac(i).X, Point_Stac(i).Y, XY_Rect)
        End If
    Next
    For i = 0 To StacNum.NodeID - 1
        If (Tokyo_Island_f = False And NodeID_Stac(i).Y >= 34.83) Or Tokyo_Island_f = True Then
            Call Get_Circumscribed_Rectangle(NodeID_Stac(i).X, NodeID_Stac(i).Y, XY_Rect)
        End If
    Next
    Get_JPGIS_MapBOX = XY_Rect
End Function


