Attribute VB_Name = "ShapeFile"
Option Explicit
Private Type XY_Genten_Info
    CenterB As Double
    CenterL As Double
End Type
Private Type XYMaxMin_Double
    XMin As Double
    Ymin As Double
    Xmax As Double
    YMax As Double
End Type
Private Type XY_Double
    X As Double
    Y As Double
End Type


Public Function ShapeFileOut(ByVal filename As String, ByVal Objn As Long, ByRef Objs() As Long, ByVal Time As Long, _
                            ByVal Data_Item_n As Long, ByRef Data_Title() As String, ByRef Data_STR_F() As Boolean, ByRef StrData() As String, lblCaption As Label) As Boolean
Dim ObjShape(2) As Long, i As Long, SP As Long, s As Long
Dim f As Boolean, filename_shx As String, filename_dbf As String

    If Objn = 0 Then
        MsgBox "IuWFNg܂B", vbExclamation
        ShapeFileOut = False
        Exit Function
    End If
    
    For i = 0 To Objn - 1
        s = MPObj(Objs(i)).Shape
        ObjShape(s) = ObjShape(s) + 1
    Next
    SP = -1
    For i = 0 To 2
        If ObjShape(i) <> 0 Then
            If SP = -1 Then
                SP = i
            Else
                SP = -2
            End If
        End If
    Next
    If SP = -2 Then
        MsgBox "IuWFNǧ`󂪓ꂳĂ܂B", vbExclamation
        ShapeFileOut = False
        Exit Function
    End If
    lblCaption.Caption = "shp,shxt@Co͒"
    lblCaption.Visible = True
    lblCaption.Refresh
    f = KillFile_if_exists(filename)
    If f = True Then
        filename_shx = Get_widthout_Extension(filename) & ".shx"
        f = KillFile_if_exists(filename_shx)
        If f = True Then
            Select Case SP
                Case PointShape
                    f = ShapeFileOut_Point(filename, Objn, Objs(), Time)
                Case LineShape
                    f = ShapeFileOut_Line(filename, Objn, Objs(), Time)
                Case PolygonShape
                    f = ShapeFileOut_Polygon(filename, Objn, Objs(), Time)
            End Select
            If f = True Then
                lblCaption.Caption = "DBFt@Co͒"
                DoEvents
                filename_dbf = Get_widthout_Extension(filename) & ".dbf"   'dbf
                f = KillFile_if_exists(filename_dbf)
                If f = True Then
                    Call DBF_Out(filename_dbf, Objn, Objs(), Time, Data_Item_n, Data_Title(), Data_STR_F(), StrData())
                End If
            End If
        End If
    End If
    If f = True Then
        If Map.Zahyo.Mode <> Zahyo_mode_info.Zahyo_No_Mode Then
            
            f = ShapeFileOut_prj(filename)
        End If
    End If
    If f = False Then
        ShapeFileOut = False
    Else
        ShapeFileOut = True
    End If
    lblCaption.Visible = False
End Function
Private Function ShapeFileOut_prj(ByVal filename As String) As Boolean
Dim filename_prj As String
Dim FreeFNum As Integer
Dim OutSTR As String
Dim XY_Genten(19) As XY_Genten_Info
Dim KNum As Integer
'prjt@Co

'ʒpWn_
    XY_Genten(1).CenterB = 33
    XY_Genten(1).CenterL = 129.5
    XY_Genten(2).CenterB = 33
    XY_Genten(2).CenterL = 131
    XY_Genten(3).CenterB = 36
    XY_Genten(3).CenterL = 132 + 10 / 60
    XY_Genten(4).CenterB = 33
    XY_Genten(4).CenterL = 133.5
    XY_Genten(5).CenterB = 36
    XY_Genten(5).CenterL = 134 + 20 / 60
    XY_Genten(6).CenterB = 36
    XY_Genten(6).CenterL = 136
    XY_Genten(7).CenterB = 36
    XY_Genten(7).CenterL = 137 + 10 / 60
    XY_Genten(8).CenterB = 36
    XY_Genten(8).CenterL = 138.5
    XY_Genten(9).CenterB = 36
    XY_Genten(9).CenterL = 139 + 50 / 60
    XY_Genten(10).CenterB = 40
    XY_Genten(10).CenterL = 140 + 50 / 60
    XY_Genten(11).CenterB = 44
    XY_Genten(11).CenterL = 140 + 15 / 60
    XY_Genten(12).CenterB = 44
    XY_Genten(12).CenterL = 142 + 15 / 60
    XY_Genten(13).CenterB = 44
    XY_Genten(13).CenterL = 144 + 15 / 60
    XY_Genten(14).CenterB = 26
    XY_Genten(14).CenterL = 142
    XY_Genten(15).CenterB = 26
    XY_Genten(15).CenterL = 127.5
    XY_Genten(16).CenterB = 26
    XY_Genten(16).CenterL = 124
    XY_Genten(17).CenterB = 26
    XY_Genten(17).CenterL = 131
    XY_Genten(18).CenterB = 20
    XY_Genten(18).CenterL = 136
    XY_Genten(19).CenterB = 26
    XY_Genten(19).CenterL = 154
    
    
    filename_prj = Get_widthout_Extension(filename) & ".prj"
    FreeFNum = FreeFile
    Open filename_prj For Output As FreeFNum
        Select Case Map.Zahyo.Mode
            Case Zahyo_mode_info.Zahyo_Ido_Keido
                Select Case Map.Zahyo.System
                    Case Zahyo_System_Info.Zahyo_System_tokyo
                        OutSTR = "GEOGCS[*GCS_Tokyo*,DATUM[*D_Tokyo*,SPHEROID[*Bessel_1841*,6377397.155,299.1528128]],PRIMEM[*Greenwich*,0.0],UNIT[*Degree*,0.0174532925199433]]"
                    Case Zahyo_System_Info.Zahyo_System_World
                        OutSTR = "GEOGCS[*GCS_JGD_2000*,DATUM[*D_JGD_2000*,SPHEROID[*GRS_1980*,6378137.0,298.257222101]],PRIMEM[*Greenwich*,0.0],UNIT[*Degree*,0.0174532925199433]]"
                End Select
            Case Zahyo_mode_info.Zahyo_HeimenTyokkaku
                KNum = Map.Zahyo.HeimenTyokkaku_KEI_Number
                Select Case Map.Zahyo.System
                    Case Zahyo_System_Info.Zahyo_System_tokyo
                        OutSTR = "PROJCS[*Japan_Zone_" & CStr(KNum) & "*,GEOGCS[*GCS_Tokyo*,DATUM[*D_Tokyo*,SPHEROID[*Bessel_1841*,6377397.155,299.1528128]],PRIMEM[*Greenwich*,0.0],UNIT[*Degree*,0.0174532925199433]],PROJECTION[*Transverse_Mercator*],PARAMETER[*False_Easting*,0.0],PARAMETER[*False_Northing*,0.0],PARAMETER[*Central_Meridian*," & CStr(XY_Genten(KNum).CenterL) & "],PARAMETER[*Scale_Factor*,0.9999],PARAMETER[*Latitude_Of_Origin*," & CStr(XY_Genten(Map.Zahyo.HeimenTyokkaku_KEI_Number).CenterB) & "],UNIT[*Meter*,1.0]]"
                    Case Zahyo_System_Info.Zahyo_System_World
                        OutSTR = "PROJCS[*JGD_2000_Japan_Zone_" & CStr(KNum) & "*,GEOGCS[*GCS_JGD_2000*,DATUM[*D_JGD_2000*,SPHEROID[*GRS_1980*,6378137.0,298.257222101]],PRIMEM[*Greenwich*,0.0],UNIT[*Degree*,0.0174532925199433]],PROJECTION[*Transverse_Mercator*],PARAMETER[*False_Easting*,0.0],PARAMETER[*False_Northing*,0.0],PARAMETER[*Central_Meridian*," & CStr(XY_Genten(KNum).CenterL) & "],PARAMETER[*Scale_Factor*,0.9999],PARAMETER[*Latitude_Of_Origin*," & CStr(XY_Genten(Map.Zahyo.HeimenTyokkaku_KEI_Number).CenterB) & "],UNIT[*Meter*,1.0]]"
                End Select
        End Select
    
    OutSTR = Replace(OutSTR, "*", Chr$(&H22))
    Print #FreeFNum, OutSTR
    Close FreeFNum
    
    ShapeFileOut_prj = True
End Function
Private Function ShapeFileOut_Polygon(ByVal filename As String, ByVal Objn As Long, ByRef Objs() As Long, ByVal Time As Long) As Boolean
'Polygon`VF[vt@Co
Dim i As Long, j As Long, k As Long
Dim Obj_Index() As Long, Obj_Length() As Long, Each_Points() As Long
Dim Arrange_LineCode() As Long, Fringe() As Fringe_Line_Info
Dim Pon As Long
Dim In_Out() As Byte, TotalInOut() As Long

Dim Bounding_Obj_box() As Box_Data
Dim Bounding_box As Box_Data
Dim PLN As Long, PN As Long, PointIndex() As Long
Dim poxy() As SingleXY, pxy() As SingleXY

Dim XY As SingleXY
Dim Flen As Long
Dim ShapeType As Long
Dim filename_shx As String
Dim filename_dbf As String
Dim D As Long, EM$
Dim Oname1 As String, Oname2 As String, Oname12 As String

    ShapeType = 5
    Call Get_Shape_Line_Polygon_Bounding_etc(ShapeType, Objn, Time, Objs(), Flen, Obj_Index(), Obj_Length(), Each_Points(), Bounding_Obj_box(), Bounding_box)
    
    'shp
    If Check_Open_Binary(filename, 1) = False Then
        ShapeFileOut_Polygon = False
        Exit Function
    End If
    Call Put_HeaderPart(Flen, ShapeType, Bounding_box, 1)
    EM$ = ""
    For i = 0 To Objn - 1
        Pon = Boundary_Arrange(Objs(i), Time, Arrange_LineCode(), Fringe())
        If Pon = -1 Then
            Call Get_Enable_ObjectName(Oname1, Oname2, Oname12, Objs(i), Time)
            MsgBox Oname12 & "͖ʌ`ɂȂĂ܂B" & CR, vbExclamation
            ShapeFileOut_Polygon = False
            Close #1
            Exit Function
        End If
        In_Out = Object_Polygon_InOut(Pon, Arrange_LineCode(), Fringe(), TotalInOut())
        ReDim pxy(Each_Points(i) - 1)
        ReDim PointIndex(Pon - 1)
        PLN = 0
        For j = 0 To Pon - 1
            PointIndex(j) = PLN
            PN = Get_Object_Polygon_Coords(j, 0, Arrange_LineCode(), Fringe(), poxy(), True)
            D = Get_Polygon_Direction(PN, poxy())
            If (TotalInOut(j) Mod 2 = 1 And D = 1) Or (TotalInOut(j) Mod 2 = 0 And D = -1) Then
                '|SŎvAłȂĔv̏ꍇ͍Wւ
                For k = 0 To PN - 1
                    pxy(k + PLN) = poxy(PN - 1 - k)
                Next
            Else
                For k = 0 To PN - 1
                    pxy(k + PLN) = poxy(k)
                Next
            End If
            PLN = PLN + PN
        Next

        Call Put_Poly_Shape_XY(ShapeType, i + 1, Pon, PLN, PointIndex(), pxy(), Bounding_Obj_box(i), 1)
        
    Next
    
    Close #1
    
    filename_shx = Get_widthout_Extension(filename) & ".shx"  'shx
    If SHX_Out(filename_shx, Objn, ShapeType, Bounding_box, Obj_Index(), Obj_Length()) = False Then
        ShapeFileOut_Polygon = False
        Exit Function
    End If
    
    
    ShapeFileOut_Polygon = True
End Function
Private Sub Put_Poly_Shape_XY(ByVal ShapeType As Long, ByVal ObID As Long, ByVal Pon As Long, ByVal PLN As Long, PointIndex() As Long, pxy() As SingleXY, Bounding_Obj_box As Box_Data, ByVal FileNum As Integer)
Dim j As Long
Dim XY As SingleXY

    Call Put_Big_Long(1, ObID)
    Call Put_Big_Long(1, CLng(2 + 4 * 4 + 2 + 2 + 2 * Pon + 4 * 2 * PLN))
    Put #FileNum, , ShapeType
    Call Put_Double_XY_from_Single_XY_Box(Bounding_Obj_box, FileNum)
    Put #FileNum, , Pon
    Put #FileNum, , PLN
    For j = 0 To Pon - 1
        Put #FileNum, , PointIndex(j)
    Next
    For j = 0 To PLN - 1
        XY = Get_Reverse_Point(pxy(j), Map)
        Call Put_Double_XY_from_Single_XY(XY, FileNum)
    Next

End Sub
Private Sub Get_Shape_Line_Polygon_Bounding_etc(ByVal ShapeType As Long, ByVal Objn As Long, ByVal Time As Long, ByRef Objs() As Long, ByRef Flen As Long, ByRef Obj_Index() As Long, ByRef Obj_Length() As Long, ByRef Each_Points() As Long, ByRef Bounding_Obj_box() As Box_Data, ByRef Bounding_box As Box_Data)
'|Sƃ|Co͂̍ۂɁA
'oEfBO{bNXACfbNXt@Cvf߂

Dim i As Long, j As Long
Dim ELine() As EnableMPLine_Data
Dim PLN As Long, NL As Long
Dim Bounding_temp_obj_box As Box_Data
Dim Bounding_temp_box As Box_Data
Dim Arrange_LineCode() As Long, Fringe() As Fringe_Line_Info
Dim L_Code() As Long
Dim Parts As Long

    ReDim Bounding_Obj_box(Objn - 1)
    ReDim Obj_Index(Objn - 1)
    ReDim Obj_Length(Objn - 1)
    ReDim Each_Points(Objn - 1)
    
    Flen = 50
    For i = 0 To Objn - 1
        Obj_Index(i) = Flen
        Select Case ShapeType
            Case 3 'PolyLine
                NL = Get_EnableMPLine(ELine(), Objs(i), Time)
                ReDim L_Code(NL - 1)
                For j = 0 To NL - 1
                    L_Code(j) = ELine(j).LineCode
                Next
                Parts = NL
            Case 5  'Polygon
                Parts = Boundary_Arrange(Objs(i), Time, Arrange_LineCode(), Fringe())
                NL = UBound(Fringe) + 1
                ReDim L_Code(NL - 1)
                For j = 0 To NL - 1
                    L_Code(j) = Fringe(j).code
                Next
        End Select
        With MPLine(L_Code(0))
            Bounding_temp_obj_box = .Circumscribed_Rectangle
            PLN = .NumOfPoint
        End With
        For j = 1 To NL - 1
            With MPLine(L_Code(j))
                Call Get_Circumscribed_Rectangle_With_Rect(.Circumscribed_Rectangle, Bounding_temp_obj_box)
                PLN = PLN + .NumOfPoint
            End With
        Next
        If i = 0 Then
            Bounding_temp_box = Bounding_temp_obj_box
        Else
            Call Get_Circumscribed_Rectangle_With_Rect(Bounding_temp_obj_box, Bounding_temp_box)
        End If
        Bounding_Obj_box(i) = Get_Reverse_Rect(Bounding_temp_obj_box, Map)
        Each_Points(i) = PLN
        Obj_Length(i) = (2 + 4 * 4 + 2 + 2 + 2 * Parts + 4 * 2 * PLN)
        Flen = Flen + (2 + 2) + Obj_Length(i)
    Next
    Bounding_box = Get_Reverse_Rect(Bounding_temp_box, Map)
        
End Sub
Private Function ShapeFileOut_Line(ByVal filename As String, ByVal Objn As Long, ByRef Objs() As Long, ByVal Time As Long) As Boolean
'PolyLine`VF[vt@Co
Dim i As Long, j As Long, k As Long
Dim Obj_Index() As Long, Obj_Length() As Long, Each_Points() As Long
Dim ELine() As EnableMPLine_Data
Dim Bounding_Obj_box() As Box_Data
Dim Bounding_box As Box_Data
Dim PLN As Long, PN As Long, NL As Long, PointIndex() As Long
Dim poxy() As SingleXY, pxy() As SingleXY

Dim XY As SingleXY
Dim Flen As Long
Dim ShapeType As Long
Dim filename_shx As String
Dim filename_dbf As String

    ShapeType = 3
    
    Call Get_Shape_Line_Polygon_Bounding_etc(ShapeType, Objn, Time, Objs(), Flen, Obj_Index(), Obj_Length(), Each_Points(), Bounding_Obj_box(), Bounding_box)
        
    'SHP
    If Check_Open_Binary(filename, 1) = False Then
        ShapeFileOut_Line = False
        Exit Function
    End If
    Call Put_HeaderPart(Flen, ShapeType, Bounding_box, 1)
    For i = 0 To Objn - 1
        NL = Get_EnableMPLine(ELine(), Objs(i), Time)
        ReDim PointIndex(NL - 1)
        ReDim pxy(Each_Points(i) - 1)
        PLN = 0
        For j = 0 To NL - 1
            PointIndex(j) = PLN
            PN = Get_Coords_by_LineCode(ELine(j).LineCode, 0, 1, poxy())
            For k = 0 To PN - 1
                pxy(k + PLN) = poxy(k)
            Next
            PLN = PLN + PN
        Next
        
        Call Put_Poly_Shape_XY(ShapeType, i + 1, NL, PLN, PointIndex(), pxy(), Bounding_Obj_box(i), 1)
        
    Next
    
    Close #1
    
    filename_shx = Get_widthout_Extension(filename) & ".shx"  'shx
    If SHX_Out(filename_shx, Objn, ShapeType, Bounding_box, Obj_Index(), Obj_Length()) = False Then
        ShapeFileOut_Line = False
        Exit Function
    End If
    
    
    ShapeFileOut_Line = True
End Function

Private Function ShapeFileOut_Point(ByVal filename As String, ByVal Objn As Long, ByRef Objs() As Long, ByVal Time As Long) As Boolean
'_`VF[vt@Co
Dim i As Long
Dim XY() As SingleXY
Dim Bounding_box As Box_Data
Dim Flen As Long
Dim ShapeType As Long
Dim filename_shx As String
Dim filename_dbf As String
Dim X1 As Single, Y1 As Single
Dim Obj_Index() As Long, Obj_Length() As Long

    ShapeType = 1
    ReDim XY(Objn - 1)
    For i = 0 To Objn - 1
        Call Get_Enable_CenterP(X1, Y1, Objs(i), Time)
        Call Get_Reverse_XY(XY(i).X, XY(i).Y, X1, Y1, Map)
        If i = 0 Then
            With Bounding_box
                .left = XY(i).X
                .top = XY(i).Y
                .right = .left
                .bottom = .top
            End With
        Else
            Call Get_Circumscribed_Rectangle(XY(i).X, XY(i).Y, Bounding_box)
        End If
    Next
    Flen = Objn * (2 + 2 + 2 + 4 + 4) + 50
    
     'shp
    If Check_Open_Binary(filename, 1) = False Then
        ShapeFileOut_Point = False
        Exit Function
    End If
    Call Put_HeaderPart(Flen, ShapeType, Bounding_box, 1)
    
    For i = 0 To Objn - 1
        Call Put_Big_Long(1, CLng(i + 1))
        Call Put_Big_Long(1, CLng(2 + 4 + 4))
        Put #1, , ShapeType
        Call Put_Double_XY_from_Single_XY(XY(i), 1)
    Next
    Close #1
    
    filename_shx = Get_widthout_Extension(filename) & ".shx"  'shx
    ReDim Obj_Index(Objn - 1)
    ReDim Obj_Length(Objn - 1)
    For i = 0 To Objn - 1
        Obj_Index(i) = 50 + i * 14
        Obj_Length(i) = 10
    Next
    If SHX_Out(filename_shx, Objn, ShapeType, Bounding_box, Obj_Index(), Obj_Length()) = False Then
        ShapeFileOut_Point = False
        Exit Function
    End If
    

    ShapeFileOut_Point = True
End Function
Private Sub Put_Double_XY_from_Single_XY(XY As SingleXY, ByVal FileNum As Long)
Dim x2 As Single, y2 As Single
'{xɂĕۑ
    Put FileNum, , CDbl(XY.X)
    Put FileNum, , CDbl(XY.Y)
End Sub
Private Sub Put_Double_XY_from_Single_XY_Box(Box As Box_Data, ByVal FileNum As Long)
Dim x2 As Single, y2 As Single
'{xɂĕۑ
    With Box
    Put FileNum, , CDbl(.left)
    Put FileNum, , CDbl(.top)
    Put FileNum, , CDbl(.right)
    Put FileNum, , CDbl(.bottom)
    End With
End Sub
Private Function SHX_Out(ByVal filename As String, ByVal Objn As Long, ByVal ShapeType As Long, ByRef Bounding_box As Box_Data, ByRef Obj_Index() As Long, ByRef Obj_Length() As Long) As Boolean
'SHX CfbNXt@Cۑ
Dim i As Long, fnum As Integer
Dim Flen As Long

    fnum = FreeFile()
    If Check_Open_Binary(filename, fnum) = False Then
        SHX_Out = False
        Exit Function
    End If

    Flen = 4 * Objn + 50
    Call Put_HeaderPart(Flen, ShapeType, Bounding_box, fnum)
    For i = 0 To Objn - 1
        Call Put_Big_Long(fnum, Obj_Index(i))
        Call Put_Big_Long(fnum, Obj_Length(i))
    Next
    Close fnum
    SHX_Out = True

End Function
Private Sub DBF_Out(ByVal filename As String, ByVal Objn As Long, ByRef Objs() As Long, ByVal Time As Long, _
                ByVal Data_Item_n As Long, ByRef Data_Title() As String, ByRef Data_STR_F() As Boolean, ByRef StrData() As String)
Dim i As Long

Dim DBFFile As DBF

Set DBFFile = New DBF

    DBFFile.Init Data_Item_n, Objn
    For i = 0 To Data_Item_n - 1
        DBFFile.FieldStringData_Flag(i) = Data_STR_F(i)
        DBFFile.FieldName(i) = Data_Title(i)
    Next
    DBFFile.DataValueSet_Allay StrData
    DBFFile.SaveDBF (filename)
    
   Set DBFFile = Nothing

End Sub
Private Sub Put_HeaderPart(ByVal Flen As Long, ByVal ShapeType As Long, Bounding_box As Box_Data, ByVal FileNum As Long)
'Shapẽwb_

Dim db As Double
Dim V As Long



    V = 1000
    Call Put_Big_Long(FileNum, 9994)
    Call Put_Big_Long(FileNum, 0)
    Call Put_Big_Long(FileNum, 0)
    Call Put_Big_Long(FileNum, 0)
    Call Put_Big_Long(FileNum, 0)
    Call Put_Big_Long(FileNum, 0)
    Call Put_Big_Long(FileNum, Flen)
    Put FileNum, , V
    Put FileNum, , ShapeType
    Call Put_Double_XY_from_Single_XY_Box(Bounding_box, FileNum)
    db = 0#
    Put FileNum, , db
    Put FileNum, , db
    Put FileNum, , db
    Put FileNum, , db

End Sub
Private Function Put_Big_Long(ByVal Filenumber As Integer, ByVal Num As Long) As Long
Dim Bt As Byte, i As Long
Dim tp As String
    
    tp = right("00000000" & Hex$(Num), 8)
    For i = 0 To 3
        Bt = Val("&H" & Mid(tp, i * 2 + 1, 2))
        Put #Filenumber, , Bt
    Next
    
End Function
Private Function Get_Excel_Row(ByVal X As Long) As String
'ԍExcel̗iA,BjȂǂ߂
'0 -->A
'1 -->B

    If X <= 25 Then
        Get_Excel_Row = Chr(Asc("A") + X)
    Else
        Get_Excel_Row = Chr(Asc("A") + ((X) \ 26) - 1) & Chr(Asc("A") + ((X) Mod 26))
    End If
End Function
Private Function Get_Big_Long(Filenumber) As Long
Dim Bt As Byte
Dim LG As Long
    Get #Filenumber, , Bt
    LG = CLng(Bt) * 256 ^ 3
    Get #Filenumber, , Bt
    LG = LG + CLng(Bt) * 256 ^ 2
    Get #Filenumber, , Bt
    LG = LG + CLng(Bt) * 256
    Get #Filenumber, , Bt
    LG = LG + Bt
    Get_Big_Long = LG
    
End Function
Public Function Get_ShapeFile(ByVal filename As String, ByVal Obk As Long, ByVal LK As Long, ByVal Layer_f As Boolean, ByRef ShapeS As Long, ProgressLabel As ProgressLabel) As Boolean
'VF[vt@Cǂݍ
'OBkIuWFNgO[v
'LK:ԍ
'Layer_fIuWFNg1-1A2-1ȂǂƂꍇtrue
Dim i As Long, j As Long, a As Single
Dim LG As Long
Dim db As Double

Dim Contents_Box As XYMaxMin_Double
Dim NumParts As Long
Dim NumPoints As Long
Dim Shape_File_Box As XYMaxMin_Double
Dim ShapeType As Long
Dim PointIndex() As Long
Dim Points() As XY_Double
Dim C_Point As XY_Double
Dim RecordNumber As Long
Dim n As Long

    Open filename For Binary As #1
    LG = Get_Big_Long(1)  '̧كR[hu9994v
    For i = 1 To 5
        Get #1, , LG
    Next
    LG = Get_Big_Long(1)
    Get #1, , LG 'o[Wu1000v
    Get #1, , ShapeType
    Get #1, , Shape_File_Box
    Get #1, , db
    Get #1, , db
    Get #1, , db
    Get #1, , db
    Select Case ShapeType
        Case 1, 11, 21
            ShapeS = PointShape
        Case 3, 13, 23
            ShapeS = LineShape
        Case 5, 15, 25
            ShapeS = PolygonShape
        Case Else
            Msgbox_Current_Position filename & "̃VF[v^Cv͓ǂݍ߂܂B", 1
            Close
            Get_ShapeFile = False
            Exit Function
    End Select
    n = 0
    ProgressLabel.Visible = True
    ProgressLabel.Start LOF(1), filename & "ǂݍݒ"

    
    Do
    'R[hwb_
        ProgressLabel.SetValue Loc(1)
        RecordNumber = Get_Big_Long(1)  'R[hԍ
        If RecordNumber = 0 Then Exit Do
        LG = Get_Big_Long(1)  'Rec
        Get #1, , LG 'VF[v^Cv
        With Map
            Call CheckMPOb_Dim(.Kend)
            Call Init_One_Object(MPObj(.Kend))
            With MPObj(.Kend)
                .Kind = Obk
                .Shape = ShapeS
                With .NameTimeSTC(0)
                    If Layer_f = False Then
                        .Name1 = RecordNumber
                    Else
                        .Name1 = CStr(Obk + 1) & "-" & CStr(RecordNumber)
                    End If
                End With
            End With
        End With
        Select Case ShapeType
            Case 1, 11 'Point
                Get #1, , C_Point
                Select Case ShapeType
                    Case 11
                        Get #1, , db
                        Get #1, , db
                    Case 21
                        Get #1, , db
                End Select
            Case 3, 5, 13, 15, 23, 25 'Line,Polygon
                Get #1, , Contents_Box
                Get #1, , NumParts
                Get #1, , NumPoints
                ReDim PointIndex(NumParts)
                ReDim Points(NumPoints)
                For i = 0 To NumParts - 1
                    Get #1, , PointIndex(i)
                Next
                For i = 0 To NumPoints - 1
                    Get #1, , Points(i)
                Next
                Select Case ShapeType
                    Case 13, 15
                        For j = 0 To 1
                            Get #1, , db
                            Get #1, , db
                            For i = 0 To NumPoints - 1
                                Get #1, , db
                            Next
                        Next
                    Case 23, 25
                        Get #1, , db
                        Get #1, , db
                        For i = 0 To NumPoints - 1
                            Get #1, , db
                        Next
                End Select
                PointIndex(NumParts) = NumPoints
                With Map
                    Call CheckMPLine_Dim(.ALIN + NumParts)
                    With MPObj(Map.Kend)
                        .NumOfLine = NumParts
                        ReDim .LineCodeSTC(.NumOfLine - 1)
                    End With
                    
                    For i = 0 To NumParts - 1
                        Call Init_One_Line(MPLine(.ALIN + i))
                        With MPLine(.ALIN + i)
                            .NumOfPoint = PointIndex(i + 1) - PointIndex(i)
                            .LineTimeSTC(0).Kind = LK
                            ReDim .PointSTC(.NumOfPoint - 1)
                            For j = 0 To .NumOfPoint - 1
                                With .PointSTC(j)
                                    .X = Points(PointIndex(i) + j).X
                                    .Y = Points(PointIndex(i) + j).Y
                                End With
                            Next
                        End With
                        MPObj(Map.Kend).LineCodeSTC(i).LineCode = .ALIN + i
                    Next
                    .ALIN = .ALIN + NumParts
                End With
        End Select

        
        With MPObj(Map.Kend).CenterPSTC(0)
            Select Case MPObj(Map.Kend).Shape
                Case PolygonShape
                Case LineShape
                Case PointShape
                    .X = C_Point.X
                    .Y = C_Point.Y
            End Select
        End With
        
        n = n + 1
        With Map
        .Kend = .Kend + 1
        End With
    Loop While EOF(1) = False
    Close
    ProgressLabel.Visible = False
    Get_ShapeFile = True
End Function
Public Function Get_ShapeDBF(ByVal filename As String, ByVal OBj_SubNum As Long, ByVal Layer_f As Boolean, OutAtt As String) As Boolean
'DBFt@C擾
'FileName̓VF[vt@C̃pX
'Layer_fIuWFNg1-1A2-1ȂǂƂꍇtrue
'OBj_SubNumk/IuWFNgO[v̔ԍ
'OutAtt:"DBFMAP"Ȃn}t@CA"DBFDATA"Ȃ瑮f[^
Dim i As Long, j As Long, k As Long
Dim dbf_f As String, ST$()
Dim n As Long, nX As Long, nY As Long
Dim TTL() As String, UNT() As String
Dim DN_Str() As String
Dim DefAtt As String

Dim DBFFile As DBF

Set DBFFile = New DBF

    dbf_f = Get_widthout_Extension(filename) & ".dbf"
    
    If DBFFile.LoadDBF(dbf_f) = False Then
        Get_ShapeDBF = False
        Exit Function
    End If
    nX = DBFFile.FieldNumber
    nY = DBFFile.RecordNumber
    ReDim TTL(DBFFile.FieldNumber - 1)
    DN_Str = DBFFile.DataValue_Allay
    
    For i = 0 To nX - 1
        TTL(i) = DBFFile.FieldName(i)
    Next
   
   Set DBFFile = Nothing
   
   UNT = Check_DataType(nX, nY, DN_Str)
    
    
        
    Select Case OutAtt
        Case "DBFMAP"
            'n}f[^ɏƂĐݒ
            For i = 0 To nX - 1
                Call Add_one_DefAttDataSet(OBj_SubNum, TTL(i), UNT(i))
            Next
            n = -1
            Do
                n = n + 1
            Loop Until MPObj(n).Kind = OBj_SubNum
            For i = 0 To nY - 1
                DefAtt = ""
                For j = 0 To nX - 1
                     DefAtt = DefAtt & DN_Str(j, i)
                     If j <> nX - 1 Then
                        DefAtt = DefAtt & TB
                    End If
                Next
                MPObj(n + i).DefAttValue = DefAtt
            Next
        Case "DBFDATA"
            'f[^ɐݒ
            
            Call Add_one_Layer(ObjectKind(OBj_SubNum).Name, ObjectKind(OBj_SubNum).Shape, -1, nY, 0, False)
            For i = 0 To nY - 1
                With KenCode(i + Layer(OBj_SubNum).Object.Stac).Object
                    If Layer_f = False Then
                        .Name = CStr(i + 1)
                    Else
                        .Name = CStr(OBj_SubNum + 1) & "-" & CStr(i + 1)
                    End If
                    .code = KenToCode(.Name, -1)
                    Call Get_Enable_CenterP(.Symbol.X, .Symbol.Y, .code, -1)
                    .Label = .Symbol
                End With
            Next
            Call frmSettei.Set_STRData_To_Cell(OBj_SubNum, nX, nY, False, TTL(), UNT(), DN_Str())
            Call init_Multimode(OBj_SubNum)
    End Select
    
    Get_ShapeDBF = True
End Function

Public Function Check_prj_file(filename As String, ByRef D_TOKYO_f As Boolean, ByRef D_JGD_2000_f As Boolean, _
                    ByRef D_WGS84_f As Boolean, ByRef JAPAN_ZONE_f As Boolean, ByRef HeimenKeiNum As Integer) As Boolean
                    
Dim objStream As Object
Dim FData As String

    Const adReadAll = -1
    Const adTypeText = 2
    Set objStream = CreateObject("ADODB.Stream")
    With objStream
        .Open
        .Type = adTypeText
        .loadFromFile filename
        .Charset = "Shift-JIS"
        .position = 0
        FData = .readText(adReadAll)
        .Close
    End With
    Set objStream = Nothing
    FData = UCase(FData)
    
    If InStr(FData, "UNDEFINED") <> 0 Then
        Check_prj_file = False
        Exit Function
    End If
    
    D_TOKYO_f = (InStr(FData, "D_TOKYO") <> 0) '{nn
    D_JGD_2000_f = (InStr(FData, "D_JGD_2000") <> 0) 'Enn
    D_WGS84_f = ((InStr(FData, "D_WGS84") <> 0) Or (InStr(FData, "D_WGS_1984") <> 0)) 'Enn
    JAPAN_ZONE_f = (InStr(FData, "JAPAN_ZONE_") <> 0) 'ʒp
    If JAPAN_ZONE_f = True Then
        'ʒp̃][
        HeimenKeiNum = Val(Mid(FData, InStr(FData, "JAPAN_ZONE_") + 11, 2))
    End If
    Check_prj_file = True
    
End Function
