Attribute VB_Name = "TKY2JGD"
'̃W[̃vÓAyn@TKY2JGD̃\[XR[ḧꕔgpĂ܂B

'ũvÓAyn@̏F𓾂āA@̋ZpH1-No.2un2000̂߂̍Wϊ\tgEFATKY2JGDv𗘗p쐬̂łB
'iFԍ@n钲174@18NW22jv


Private Const PID As Double = 3.14159265358979
Private Const TWO_PI As Double = 6.28318530717959
Private Const HAF_PI As Double = 1.5707963267949
Private Const rad2deg As Double = 57.2957795130823     'WAxɂ邽ߊ|鐔
Private Const deg2rad As Double = 1.74532925199433E-02 'xWAɂ邽ߊ|鐔
Private Const ROBYO As Double = 206264.806247          '3600*180/PI
Private Type EllipPar 'ȉ~̃p[^̍\̂`
  a As Double   'semimajor axix in meter
  f1 As Double  'reciprocal flattening
  f As Double   'flattening
  E As Double   'squared eccentricity
  namec As String 'ellipsoid name
End Type
Dim EP(1 To 2) As EllipPar   'EP(1)Besselȉ~́CEP(2)GRS-80ȉ~
Private Type XY_Genten_Info
    CenterB As Double
    CenterL As Double
End Type
Dim XY_Genten(19) As XY_Genten_Info

Private Sub Set_EP_Parameter()
  EP(1).a = 6377397.155
  EP(1).f1 = 299.152813
  EP(1).namec = "Bessel"
  EP(1).f = 1# / EP(1).f1
  EP(1).E = (2# * EP(1).f1 - 1#) / EP(1).f1 / EP(1).f1  '=e*e (squared e)
  EP(2).a = 6378137#
  EP(2).f1 = 298.257222101
  EP(2).namec = "GRS-80"
  EP(2).f = 1# / EP(2).f1
  EP(2).E = (2# * EP(2).f1 - 1#) / EP(2).f1 / EP(2).f1  '=e*e (squared e)

    XY_Genten(1).CenterB = 33
    XY_Genten(1).CenterL = 129.5
    XY_Genten(2).CenterB = 33
    XY_Genten(2).CenterL = 131
    XY_Genten(3).CenterB = 36
    XY_Genten(3).CenterL = 132 + 10 / 60
    XY_Genten(4).CenterB = 33
    XY_Genten(4).CenterL = 133.5
    XY_Genten(5).CenterB = 36
    XY_Genten(5).CenterL = 134 + 20 / 60
    XY_Genten(6).CenterB = 36
    XY_Genten(6).CenterL = 136
    XY_Genten(7).CenterB = 36
    XY_Genten(7).CenterL = 137 + 10 / 60
    XY_Genten(8).CenterB = 36
    XY_Genten(8).CenterL = 138.5
    XY_Genten(9).CenterB = 36
    XY_Genten(9).CenterL = 139 + 50 / 60
    XY_Genten(10).CenterB = 40
    XY_Genten(10).CenterL = 140 + 50 / 60
    XY_Genten(11).CenterB = 44
    XY_Genten(11).CenterL = 140 + 15 / 60
    XY_Genten(12).CenterB = 44
    XY_Genten(12).CenterL = 142 + 15 / 60
    XY_Genten(13).CenterB = 44
    XY_Genten(13).CenterL = 144 + 15 / 60
    XY_Genten(14).CenterB = 26
    XY_Genten(14).CenterL = 142
    XY_Genten(15).CenterB = 26
    XY_Genten(15).CenterL = 127.5
    XY_Genten(16).CenterB = 26
    XY_Genten(16).CenterL = 124
    XY_Genten(17).CenterB = 26
    XY_Genten(17).CenterL = 131
    XY_Genten(18).CenterB = 20
    XY_Genten(18).CenterL = 136
    XY_Genten(19).CenterB = 26
    XY_Genten(19).CenterL = 154

End Sub
Sub Tokyo97toITRF94(ByVal B1 As Double, ByVal L1 As Double, ByRef B2 As Double, ByRef L2 As Double)
' Ver.1.1  1999/1/28  (C) Mikio TOBITA cjCyn@
' u3ҰɂvTokyo97nITRF94nւ̍WϊsB
'  ̕ϊł͑ȉ~̍H̓[ƂB
' by cj
' ́@B1    : ܓx(x)
' @@@L1    : ox(x)
' ó@B2    : ܓx(x)
' @@@L2    : ox(x)
  Dim Brad As Double, ALrad As Double 'ܓxCox(radian)
  Dim H As Double                     'ȉ~̍(m)
  Dim X1 As Double, Y1 As Double, Z1 As Double, x2 As Double, y2 As Double, Z2 As Double '(m)
  
  Call Set_EP_Parameter
  
  Brad = B1 * deg2rad
  ALrad = L1 * deg2rad
  
  'ܓxCoxOWn(X,Y,Z)ւ̊Z
  Call BLHXYZcalc(Brad, ALrad, 0, X1, Y1, Z1, EP(1)) 'EP(1):Besselȉ~
  'OWn(X,Y,Z)OWn(X,Y,Z)ւ̍Wϊ
  Call xyz2xyz(X1, Y1, Z1, x2, y2, Z2)
  'OWn(X,Y,Z)ܓxCoxւ̊Z
  Call XYZBLHcalc(x2, y2, Z2, Brad, ALrad, H, EP(2)) 'EP(2):GRS-80ȉ~
  
  B2 = Brad * rad2deg
  L2 = ALrad * rad2deg
End Sub
Sub ITRF94toTokyo97(ByVal B1 As Double, ByVal L1 As Double, B2 As Double, L2 As Double)
' Ver.1.1  1999/1/28  (C) Mikio TOBITA cjCyn@
' u3ҰɂvITRF94nTokyo97nւ̍WϊsB
'  ̕ϊł͑ȉ~̍H́Cϊ̐ʒuB2,L2𐳊mɌɖ߂߁C2XebvŕϊB
'@(1)l̓[ƂxϊƁC(2)̎Hʂ𗚂CxϊB
' by cj
' ́@B1    : ܓx(x)
' @@@L1    : ox(x)
' ó@B2    : ܓx(x)
' @@@L2    : ox(x)
  Dim Brad1 As Double, ALrad1 As Double 'ܓxCox(radian)
  Dim Brad2 As Double, ALrad2 As Double 'ܓxCox(radian)
  Dim H As Double                       'ȉ~̍(m)
  Dim X1 As Double, Y1 As Double, Z1 As Double, x2 As Double, y2 As Double, Z2 As Double '(m)
  
Call Set_EP_Parameter

  Brad1 = B1 * deg2rad
  ALrad1 = L1 * deg2rad
  
  '(1)
  'ܓxCoxOWn(X,Y,Z)ւ̊Z
  Call BLHXYZcalc(Brad1, ALrad1, 0#, X1, Y1, Z1, EP(2))  'EP(2):GRS-80ȉ~
  'OWn(X,Y,Z)OWn(X,Y,Z)ւ̍Wϊ
  Call xyz2xyzR(X1, Y1, Z1, x2, y2, Z2)
  'OWn(X,Y,Z)ܓxCoxւ̊Z
  Call XYZBLHcalc(x2, y2, Z2, Brad2, ALrad2, H, EP(1)) 'EP(1):Besselȉ~
  '(2)
  'ܓxCoxOWn(X,Y,Z)ւ̊Z
  Call BLHXYZcalc(Brad1, ALrad1, -H, X1, Y1, Z1, EP(2))  'EP(2):GRS-80ȉ~
  'OWn(X,Y,Z)OWn(X,Y,Z)ւ̍Wϊ
  Call xyz2xyzR(X1, Y1, Z1, x2, y2, Z2)
  'OWn(X,Y,Z)ܓxCoxւ̊Z
  Call XYZBLHcalc(x2, y2, Z2, Brad2, ALrad2, H, EP(1)) 'EP(1):Besselȉ~
  
  B2 = Brad2 * rad2deg
  L2 = ALrad2 * rad2deg
End Sub
Sub BLHXYZcalc(Brad As Double, ALrad As Double, H As Double, X As Double, Y As Double, z As Double, EP As EllipPar) '________________________
' Ver.1.2  1999/1/29 (C) Mikio TOBITA cjCyn@
'   Ver.1.2CEllipPar TypeɑΉ
' B,L,HX,Y,ZɕϊB ̂Ƃȉ~̂w肷KvB
' ́@ Brad : ܓx(RADIAN)
'     @ALrad : ox(RADIAN)
'        H    : (m)
'        A    : ȉ~̂̒a(m)
'        FI   : ȉ~̂̕Ε̋t
'        E    : ȉ~̗̂ŜQ
' ó@ X    : RWn(m)
'        Y    : RWn(m)
'        Z    : RWn(m)
Dim CB As Double, CL As Double, SB As Double, SL As Double, w As Double, an As Double
Dim a As Double, fi As Double, E As Double
a = EP.a
fi = EP.f1
E = EP.E
CB = Cos(Brad): SB = Sin(Brad)
CL = Cos(ALrad): SL = Sin(ALrad)
w = Sqr(1# - E * SB * SB)
an = a / w
X = (an + H) * CB * CL
Y = (an + H) * CB * SL
z = (an * (1# - E) + H) * SB
End Sub

Private Sub xyz2xyzR(X1 As Double, Y1 As Double, Z1 As Double, x2 As Double, y2 As Double, Z2 As Double)
' Ver.2.3  1999/5/30  (C) Mikio TOBITA cjCyn@
' Wϊ܂B
' tϊ R:Reverse
' ϊҰ́CITRF94Tokyo97ŒƂ܂BTKY2JGDpȂ̂ŁB
' Wϊ܂B
'  |XS| |X| |T1| | D  -R3  R2||X|
'  |YS|=|Y|+|T2|+| R3  D  -R1||Y|   cf. IERS ANNUAL REPORT FOR 1989
'  |ZS| |Z| |T3| |-R2  R1  D ||Z|                             II-23
'  ́@X1, Y1, Z1 : RWnł̍W (m)
'  ó@X2, Y2, Z2 : RWnł̍W (m)
'  Wϊp[^Bp[^t@C̃tH[}bgB
'         T1   : X shift(cm)
'         T2   : Y shift(cm)
'         T3   : Z shift(cm)
'         D    : scale factor (e-8)
'         R1   : rotation around X axis (marcsec)
'         R2   : rotation around Y axis (marcsec)
'         R3   : rotation around Z axis (marcsec)
'  ۂɌvZƂ̃tH[}bgł̍Wϊp[^B
'       T1real : X shift(m)
'       T2real : Y shift(m)
'       T3real : Z shift(m)
'        Dreal : scale factor (e-0)
'       R1real : rotation around X axis (radian)
'       R2real : rotation around Y axis (radian)
'       R3real : rotation around Z axis (radian)
  Dim T1 As Double, T2 As Double, T3 As Double, D As Double
  Dim r1 As Double, r2 As Double, R3 As Double
  Dim T1real As Double, T2real As Double, T3real As Double, Dreal As Double
  Dim R1real As Double, R2real As Double, R3real As Double

'p[^̑@ITRF94Tokyo97
' -14641.40   50733.70   68050.70    0.00    0.00    0.00    0.00       Tokyo97        ITRF94
    T1 = 14641.4
    T2 = -50733.7
    T3 = -68050.7
    'D = 0#
    'R1 = 0#
    'R2 = 0#
    'R3 = 0#
'ۂɎgϊp[^̌vZ
  T1real = T1 * 0.01                   '      cm to m
  T2real = T2 * 0.01                   '      cm to m
  T3real = T3 * 0.01                   '      cm to m
  'Dreal = D * 0.00000001               '     e-8 to e-0
  'R1real = R1 * 0.001 / 3600# * deg2rad ' marcsec to radian
  'R2real = R2 * 0.001 / 3600# * deg2rad
  'R3real = R3 * 0.001 / 3600# * deg2rad

  'ʓIɂ͂Vp[^Ŏ̂悤ɕϊ܂Cł3p[^Ȃ̂ŕsvȌvZ͏ȗ܂B
  'X2 = X1 + T1real + Dreal * X1 - R3real * Y1 + R2real * Z1
  'Y2 = Y1 + T2real + R3real * X1 + Dreal * Y1 - R1real * Z1
  'Z2 = Z1 + T3real - R2real * X1 + R1real * Y1 + Dreal * Z1
  x2 = X1 + T1real
  y2 = Y1 + T2real
  Z2 = Z1 + T3real

End Sub
Private Sub XYZBLHcalc(X As Double, Y As Double, z As Double, Brad As Double, ALrad As Double, H As Double, EP As EllipPar) '________________________
' Ver.2.2  1999/1/29 (C) Mikio TOBITA cjCyn@
'   Ver.2.2CEllipPar TypeɑΉ
' X,Y.ZB,L,HɕϊB ̂Ƃȉ~̂w肷KvB
' ́@ X    : RWn(m)
'        Y    : RWn(m)
'        Z    : RWn(m)
'        A    : ȉ~̂̒a(m)
'        FI   : ȉ~̂̕Ε̋t
'        E    : ȉ~̗̂ŜQ
' ó@ Brad : ܓx(RADIAN)
'     @ALrad : ox(RADIAN)
'        H    : (m)
Static P2 As Double, p As Double, r As Double
Static myu As Double, myus3 As Double, myuc3 As Double
Static tmp As Double
Dim a As Double, fi As Double, E As Double
a = EP.a
fi = EP.f1
E = EP.E

P2 = X * X + Y * Y
p = Sqr(P2)
If p = 0 Then
  frmMain!lblStatus.Backcolor = &HFF&
  frmMain!lblStatus = "Warning: Wl(X,Y,Z)͂ĉB"
  Exit Sub
End If
If X = 0 Then
  ALrad = HAF_PI
Else
  ALrad = atn(Y / X) 'ox
End If
If X < 0 Then ALrad = ALrad + PID
If ALrad > PID Then ALrad = ALrad - TWO_PI

r = Sqr(P2 + z * z)
myu = atn((z / p) * (1# - (1# / fi) + E * a / r))
myus3 = Sin(myu)
myus3 = myus3 * myus3 * myus3
myuc3 = Cos(myu)
myuc3 = myuc3 * myuc3 * myuc3
Brad = atn((z * (1# - 1# / fi) + E * a * myus3) / ((1# - 1# / fi) * (p - E * a * myuc3)))
H = p * Cos(Brad) + z * Sin(Brad) - a * Sqr(1# - E * Sin(Brad) * Sin(Brad))    'ȉ~̍

End Sub

Private Sub xyz2xyz(X1 As Double, Y1 As Double, Z1 As Double, x2 As Double, y2 As Double, Z2 As Double)
' Ver.2.2  1999/1/29 (C) Mikio TOBITA cjCyn@
' Wϊ܂B
' ϊҰ́CTokyo97ITRF94ŒƂ܂BTKY2JGDpȂ̂ŁB
'  |XS| |X| |T1| | D  -R3  R2||X|
'  |YS|=|Y|+|T2|+| R3  D  -R1||Y|   cf. IERS ANNUAL REPORT FOR 1989
'  |ZS| |Z| |T3| |-R2  R1  D ||Z|                             II-23
'  ́@X1, Y1, Z1 : RWnł̍W (m)
'  ó@X2, Y2, Z2 : RWnł̍W (m)
'  Wϊp[^Bp[^t@C̃tH[}bgB
'         T1   : X shift(cm)
'         T2   : Y shift(cm)
'         T3   : Z shift(cm)
'         D    : scale factor (e-8)
'         R1   : rotation around X axis (marcsec)
'         R2   : rotation around Y axis (marcsec)
'         R3   : rotation around Z axis (marcsec)
'  ۂɌvZƂ̃tH[}bgł̍Wϊp[^B
'       T1real : X shift(m)
'       T2real : Y shift(m)
'       T3real : Z shift(m)
'        Dreal : scale factor (e-0)
'       R1real : rotation around X axis (radian)
'       R2real : rotation around Y axis (radian)
'       R3real : rotation around Z axis (radian)
  Dim T1 As Double, T2 As Double, T3 As Double, D As Double
  Dim r1 As Double, r2 As Double, R3 As Double
  Dim T1real As Double, T2real As Double, T3real As Double, Dreal As Double
  Dim R1real As Double, R2real As Double, R3real As Double
'p[^̑@Tokyo97ITRF94
' -14641.40   50733.70   68050.70    0.00    0.00    0.00    0.00       Tokyo97        ITRF94
    T1 = -14641.4
    T2 = 50733.7
    T3 = 68050.7
    'D = 0#
    'R1 = 0#
    'R2 = 0#
    'R3 = 0#
'ۂɎgϊp[^̌vZ
  T1real = T1 * 0.01                   '      cm to m
  T2real = T2 * 0.01                   '      cm to m
  T3real = T3 * 0.01                   '      cm to m
  'Dreal = D * 0.00000001               '     e-8 to e-0
  'R1real = R1 * 0.001 / 3600# * deg2rad ' marcsec to radian
  'R2real = R2 * 0.001 / 3600# * deg2rad
  'R3real = R3 * 0.001 / 3600# * deg2rad
 
  'ʓIɂ͂Vp[^Ŏ̂悤ɕϊ܂Cł3p[^Ȃ̂ŕsvȌvZ͏ȗ܂B
  'X2 = X1 + T1real + Dreal * X1 - R3real * Y1 + R2real * Z1
  'Y2 = Y1 + T2real + R3real * X1 + Dreal * Y1 - R1real * Z1
  'Z2 = Z1 + T3real - R2real * X1 + R1real * Y1 + Dreal * Z1
  x2 = X1 + T1real
  y2 = Y1 + T2real
  Z2 = Z1 + T3real

End Sub

Public Sub doCalcXy2bl(Ellip12 As Integer, ByVal Kei As Integer, ByVal X As Double, ByVal Y As Double, ByRef OutB As Double, ByRef OutL As Double)
' Ver.1.3  1999/10/19  (C) Mikio TOBITA cjCyn@
' ʒpWX,Yܓx,oxɊZ܂B
' unԈꎟ_ʌvZv𓱓̗̍pB
' NAD83 Datum Sheet DatãAXJ̓_ŉvŽox0.00156b̂0.00000bɂB
' Ellip12=1: Besselȉ~
' Ellip12=2: GRS80ȉ~
'̌vZ͕ϊ̑1iKȂ̂ňܓxox͒lKv
  Dim M0 As Double 'Kei As Integer   'nԍCqߐ̏kڌW
'  Dim X As Double, Y As Double       'ʒpWB͒lBmeter
  Dim cB1 As Double, cL1 As Double   '_̈ܓxCoxBc = combo box
  Dim B1 As Double, L1 As Double     '_̈ܓxCoxB{Iradian
  Dim b As Double, L As Double       '߂ܓxCoxB{Iradian
  Dim Bdeg As Double, Ldeg As Double '߂ܓxCoxB{Ideg
  Dim Gamma As Double                '= qߐpBradian
  Dim Gammadeg As Double             '^kpBdeg
  Dim MMM As Double                  'kڌW
  Dim D As Integer, AM As Integer, s As Double, SN As Integer, SNS As String
  Dim AEE As Double, CEE As Double, Ep2 As Double
  Dim AJ As Double, BJ As Double, CJ As Double, DJ As Double, EJ As Double
  Dim FJ As Double, GJ As Double, HJ As Double, IJ As Double
  Dim S0 As Double                   'ԓW_܂ł̎qߐʒ
  Dim M As Double
  Dim Eta2 As Double, M1 As Double, N1 As Double         'phi1̊֐
  Dim Eta2phi As Double, Mphi As Double, Nphi As Double  'phi(=B)̊֐
  Dim T As Double, T2 As Double, T4 As Double, T6 As Double
  Dim e2 As Double, e4 As Double, e6 As Double, e8 As Double, e10 As Double
  Dim e12 As Double, e14 As Double, e16 As Double
  Dim S1 As Double, phi1 As Double, oldphi1 As Double, icount As Integer
  Dim Bunsi As Double, Bunbo As Double
  Dim YM0 As Double, N1CosPhi1 As Double
  Dim EPs As EllipPar
  
  'qߐ̏kڌW
  M0 = 0.9999
  
  Call Set_EP_Parameter
  
  'ȉ~Ұ̑
  EPs.a = EP(Ellip12).a
  EPs.f1 = EP(Ellip12).f1
  EPs.f = EP(Ellip12).f
  EPs.E = EP(Ellip12).E
  EPs.namec = EP(Ellip12).namec
  e2 = EPs.E: e4 = e2 * e2: e6 = e4 * e2: e8 = e4 * e4: e10 = e8 * e2
  e12 = e8 * e4: e14 = e8 * e6: e16 = e8 * e8

  '萔 the same as bl2xy
  AEE = EPs.a * (1# - EPs.E)      'a(1-e2)
  CEE = EPs.a / Sqr(1# - EPs.E)   'C=a*sqr(1+e'2)=a/sqr(1-e2)
  Ep2 = EPs.E / (1# - EPs.E)      'e'2 (e prime 2) Eta2vZ邽
 
  'uܓx^Đԓ̎qߐʒ߂vZv̂߂̂X̌W߂B
  'unԈꎟ_ʌvZvP55,P56BW`FbNς1999/10/19B
  AJ = 4927697775# / 7516192768# * e16
  AJ = AJ + 19324305# / 29360128# * e14
  AJ = AJ + 693693# / 1048576# * e12
  AJ = AJ + 43659# / 65536# * e10
  AJ = AJ + 11025# / 16384# * e8
  AJ = AJ + 175# / 256# * e6
  AJ = AJ + 45# / 64# * e4
  AJ = AJ + 3# / 4# * e2
  AJ = AJ + 1#
  BJ = 547521975# / 469762048# * e16
  BJ = BJ + 135270135# / 117440512# * e14
  BJ = BJ + 297297# / 262144# * e12
  BJ = BJ + 72765# / 65536# * e10
  BJ = BJ + 2205# / 2048# * e8
  BJ = BJ + 525# / 512# * e6
  BJ = BJ + 15# / 16# * e4
  BJ = BJ + 3# / 4# * e2
  CJ = 766530765# / 939524096# * e16
' CJ = CJ + 45090045# / 5870256# * e14 nԈꎟ_ʍƋǨɂoO
  CJ = CJ + 45090045# / 58720256# * e14
  CJ = CJ + 1486485# / 2097152# * e12
  CJ = CJ + 10395# / 16384# * e10
  CJ = CJ + 2205# / 4096# * e8
  CJ = CJ + 105# / 256# * e6
  CJ = CJ + 15# / 64# * e4
  DJ = 209053845# / 469762048# * e16
  DJ = DJ + 45090045# / 117440512# * e14
  DJ = DJ + 165165# / 524288# * e12
  DJ = DJ + 31185# / 131072# * e10
  DJ = DJ + 315# / 2048# * e8
  DJ = DJ + 35# / 512# * e6
  EJ = 348423075# / 1879048192# * e16
  EJ = EJ + 4099095# / 29360128# * e14
  EJ = EJ + 99099# / 1048576# * e12
  EJ = EJ + 3465# / 65536# * e10
  EJ = EJ + 315# / 16384# * e8
  FJ = 26801775# / 469762048# * e16
  FJ = FJ + 4099095# / 117440512# * e14
  FJ = FJ + 9009# / 524288# * e12
  FJ = FJ + 693# / 131072# * e10
  GJ = 11486475# / 939524096# * e16
  GJ = GJ + 315315# / 58720256# * e14
  GJ = GJ + 3003# / 2097152# * e12
  HJ = 765765# / 469762048# * e16
  HJ = HJ + 45045# / 117440512# * e14
  IJ = 765765# / 7516192768# * e16
     
  'WnԍCܓxCox̓ǂ݂Ƃ
'  Kei = Mid$(frmMain!cmbPara.Text, 1, 2)  'nԍ
'  cB1 = Mid$(frmMain!cmbPara.Text, 5, 7)  '_ܓx
'  cL1 = Mid$(frmMain!cmbPara.Text, 14, 8) '_ox
'  Call dms2deg(cB1, B1, SN, D, AM, S)
'  Call dms2deg(cL1, L1, SN, D, AM, S)
  B1 = XY_Genten(Kei).CenterB * deg2rad
  L1 = XY_Genten(Kei).CenterL * deg2rad
  
On Error GoTo ErrorHandler          ' G[NƃG[[`ɔт܂B
  'X,Y̓
'  If Ellip12 = 1 Then
'    X = CDbl(frmMain.txtTkyx)
'    Y = CDbl(frmMain.txtTkyy)
'  Else
'    X = CDbl(frmMain.txtJgdx)
'    Y = CDbl(frmMain.txtJgdy)
'  End If
  
  'ԓ̎qߐ̌vZ
  Call MeridS(B1, AEE, AJ, BJ, CJ, DJ, EJ, FJ, GJ, HJ, IJ, S0) 'ԓW_܂ł̎qߐʒ
  M = S0 + X / M0
  
  'Bailey̎ɂِܓxiisometric latitudejphi1̌vZB
  'unԈꎟ_ʌvZvP5711.(1)̎B
  '̎Ɓu㑪ʊwP ʂ̐wIbvP102̎Ƃ́CCos(phi1)قȂB
  '̎𓱓߃xbZȉ~̈ȊOŉvZOKƂȂB
  icount = 0
  phi1 = B1
  Do
    icount = icount + 1
    oldphi1 = phi1
    Call MeridS(phi1, AEE, AJ, BJ, CJ, DJ, EJ, FJ, GJ, HJ, IJ, S1) 'ԓ_܂ł̎qߐʒ
    Bunsi = 2# * (S1 - M) * (1# - EPs.E * Sin(phi1) * Sin(phi1)) ^ 1.5
    Bunbo = 3# * EPs.E * (S1 - M) * Sin(phi1) * Cos(phi1) * Sqr(1# - EPs.E * Sin(phi1) * Sin(phi1)) - 2# * EPs.a * (1# - EPs.E)
    phi1 = phi1 + Bunsi / Bunbo
    If icount > 100 Then MsgBox "ِܓx߂̂Ɏ܂B", , App.EXEName
  Loop Until ((Abs(phi1 - oldphi1) < 0.00000000000001) Or (icount > 100)) '{ł1e-12ŏ\@iteration̉񐔂͂S
  
  'xgϐɑ
  YM0 = Y / M0
  T = Tan(phi1)  'unԈꎟ_ʌvZvP51t1ɓ
  T2 = T * T: T4 = T2 * T2: T6 = T4 * T2
  Eta2 = Ep2 * Cos(phi1) * Cos(phi1)     '=1*1
  M1 = CEE / Sqr((1# + Eta2) ^ 3#)
  N1 = CEE / Sqr(1# + Eta2)
  N1CosPhi1 = N1 * Cos(phi1)
    
  'ܓxB̌vZ unԈꎟ_ʌvZvP51phi߂鎮
  b = ((1385# + 3633# * T2 + 4095 * T4 + 1575# * T6) / (40320# * N1 ^ 8#)) * YM0 ^ 8#
  b = b - ((61# + 90# * T2 + 45 * T4 + 107# * Eta2 - 162# * T2 * Eta2 - 45# * T4 * Eta2) / (720# * N1 ^ 6#)) * YM0 ^ 6#
  b = b + ((5# + 3# * T2 + 6# * Eta2 - 6# * T2 * Eta2 - 3# * Eta2 ^ 2 - 9# * T2 * Eta2 ^ 2) / (24# * N1 ^ 4#)) * YM0 ^ 4#
  b = b - ((1# + Eta2) / (2# * N1 ^ 2#)) * YM0 ^ 2#
  b = b * T
  b = b + phi1
  
  'oxĽvZ unԈꎟ_ʌvZvP51̃ɂ߂鎮
  L = -((61# + 662# * T2 + 1320# * T4 + 720# * T6) / (5040# * N1 ^ 6# * N1CosPhi1)) * YM0 ^ 7#
  L = L + ((5# + 28# * T2 + 24# * T4 + 6# * Eta2 + 8# * T2 * Eta2) / (120# * N1 ^ 4# * N1CosPhi1)) * YM0 ^ 5#
  L = L - ((1# + 2# * T2 + Eta2) / (6# * N1 ^ 2# * N1CosPhi1)) * YM0 ^ 3#
  L = L + (1# / N1CosPhi1) * YM0
  L = L + L1

  'qߐp̌vZ unԈꎟ_ʌvZvP51̃߂鎮
  Gamma = ((1# + T2) * (2# + 3# * T2) / (15# * N1 ^ 5#)) * (Y / M0) ^ 5#
  Gamma = Gamma - ((1# + T2 - Eta2) / (3# * N1 ^ 3#)) * (Y / M0) ^ 3#
  Gamma = Gamma + (1# / N1) * Y / M0
  Gamma = Gamma * T

  'kڌW̌vZ unԈꎟ_ʌvZvP51m߂鎮
  Eta2phi = Ep2 * Cos(b) * Cos(b)     '=*ŁBBphiƓB
  Mphi = CEE / Sqr((1# + Eta2phi) ^ 3#)
  Nphi = CEE / Sqr(1# + Eta2phi)
  MMM = Y ^ 4# / (24# * Mphi * Mphi * Nphi * Nphi * M0 ^ 4#)
  MMM = MMM + Y * Y / (2# * Mphi * Nphi * M0 ^ 2#)
  MMM = MMM + 1#
  MMM = MMM * M0

  'o
  Bdeg = b * rad2deg
  Ldeg = L * rad2deg
  
  OutB = Bdeg
  OutL = Ldeg
  'qߐpGamma(rad)C^kpGammadeg(degree)
'  Gammadeg = -Gamma * rad2deg
'
'  Call deg2dms(Bdeg, D, AM, S, SNS)
'  If Ellip12 = 1 Then
'    frmMain.txtTB = SNS & Format$(D, "###") & Format$(AM, "00") & Format$(S, "00.00000")
'  Else
'    frmMain.txtJB = SNS & Format$(D, "###") & Format$(AM, "00") & Format$(S, "00.00000")
'  End If
'
'  Call deg2dms(Ldeg, D, AM, S, SNS)
'  If Ellip12 = 1 Then
'    frmMain.txtTL = SNS & Format$(D, "###") & Format$(AM, "00") & Format$(S, "00.00000")
'  Else
'    frmMain.txtJL = SNS & Format$(D, "###") & Format$(AM, "00") & Format$(S, "00.00000")
'  End If
'
'  Call deg2dms3(Gammadeg, D, AM, S, SNS)
'  If Ellip12 = 1 Then
'    frmMain.lblTkyn = SNS & Format$(D, "###") & Format$(AM, "00") & Format$(S, "00.000")
'  Else
'    frmMain.lblJgdn = SNS & Format$(D, "###") & Format$(AM, "00") & Format$(S, "00.000")
'  End If
'
'  If Ellip12 = 1 Then
'    frmMain.lblTkys = Format(MMM, "#.00000000") 'ʕ\͏_ȉU
'  Else
'    frmMain.lblJgds = Format(MMM, "#.00000000") 'ʕ\͏_ȉU
'  End If

On Error GoTo 0                 ' G[̃gbv𖳌ɂ܂B
Exit Sub                                ' G[[`sȂ悤 Sub I܂B

ErrorHandler:                           ' G[[`B
    Select Case Err.Number              ' G[ԍ]܂B
        Case 6                          ' "I[o[t[܂B" ƂG[łB
          frmMain.lblStatus.Backcolor = &HFF00&
          frmMain.lblStatus = "͂ꂽX,Y̒lɖ肪܂BvZ͍s܂B in doCalcXy2bl"
          Exit Sub
        Case Else                       ' ̃G[ɋLq܂B
          MsgBox Err.Description & "͂ꂽX,Y̒lɖ肪Ǝv܂BvZ͍s܂B in doCalcXy2bl"
          Exit Sub
    End Select
    Resume                              ' G[s珈ĊJ܂B
End Sub

Private Sub MeridS(Phi As Double, AEE As Double, AJ As Double, BJ As Double, CJ As Double, DJ As Double, EJ As Double, FJ As Double, GJ As Double, HJ As Double, IJ As Double, SS As Double)
' Ver.1.3  1999/10/19  (C) Mikio TOBITA cjCyn@
' ԓܓxPhi܂ł̎qߐʒvZ܂B
'unԈꎟ_ʌvZvP55
  SS = IJ / 16# * Sin(16# * Phi)
  SS = SS - HJ / 14# * Sin(14# * Phi)
  SS = SS + GJ / 12# * Sin(12# * Phi)
  SS = SS - FJ / 10# * Sin(10# * Phi)
  SS = SS + EJ / 8# * Sin(8# * Phi)
  SS = SS - DJ / 6# * Sin(6# * Phi)
  SS = SS + CJ / 4# * Sin(4# * Phi)
  SS = SS - BJ / 2# * Sin(2# * Phi)
  SS = SS + AJ * Phi
  SS = AEE * SS
End Sub

